#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"


#include "valuescript.h"
#include "conditionscript.h"
#include "actionscript.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BIntegerEdDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"
#include "TileViewWnd.h"
#include "TileSelectionWnd.h"
#include "ValueScriptWnd.h"
#include "ConditionScriptWnd.h"
#include "interfaces.h"

#include "editor.h" 

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

extern int SCREEN_X,SCREEN_Y;

extern int condition_cmd_id[CONDITION_MAX_CMD];
extern char *condition_cmd_pat[CONDITION_MAX_CMD];

/*
int condition_cmd_id[CONDITION_MAX_CMD] = {CONDITION_CMD_TRUE,
										   CONDITION_CMD_FALSE,
										   CONDITION_CMD_NOT,
										   CONDITION_CMD_AND,

										   CONDITION_CMD_OR,
										   CONDITION_CMD_TIMMER,
										   CONDITION_CMD_COLLISION,
										   CONDITION_CMD_COLLISION_WITH_OBJECT,

										   CONDITION_CMD_INSIDE_ROOM,
										   CONDITION_CMD_PARTIALLY_INSIDE_ROOM,
										   CONDITION_CMD_SENSE_OBJECT,
										   CONDITION_CMD_SENSE_SPECIFIC_OBJECT,

										   CONDITION_CMD_KEYPRESS,
										   CONDITION_CMD_KEYPRESSED,
										   CONDITION_CMD_VARIABLE_EQ,
										   CONDITION_CMD_VARIABLE_GR,

										   CONDITION_CMD_VARIABLE_GREQ,
										   CONDITION_CMD_VARIABLE_LW,
										   CONDITION_CMD_VARIABLE_LWEQ,
										   CONDITION_CMD_FIND_SUBSTRING,

										   CONDITION_CMD_INVINCIBLE,
										   CONDITION_CMD_INLADDER,
										   CONDITION_CMD_H_COLLISION,
										   CONDITION_CMD_H_COLLISION_WITH_OBJECT,

										   CONDITION_CMD_H_INSIDE_ROOM,
										   CONDITION_CMD_H_PARTIALLY_INSIDE_ROOM,
										   CONDITION_CMD_LOADGAME,
										   CONDITION_CMD_SAVEGAME};
*/
/*

  Tokens:
  %VS: Value script
  %CS: condition script
  %L: a list of all the condition scripts

*/
/*
char *condition_cmd_pat[CONDITION_MAX_CMD] ={"TRUE",
											 "FALSE",
											 "NOT( %CS )",
											 "AND( %L )",
									 
											 "OR( %L )",
											 "TIMMER( %VS )",
											 "COLLISION( %VS , %VS )",
											 "COLLISION_WITH_OBJECT( %VS , %VS , %VS , %CS )",

											 "INSIDE_ROOM( %VS , %VS )",
											 "PARTIALLY_INSIDE_ROOM( %VS , %VS )",
											 "SENSE_OBJECT( %VS , %VS , %VS , %VS , %VS , %CS )",
											 "SENSE_SPECIFIC_OBJECT( %VS , %VS , %VS , %VS , %VS , %CS )",

											 "KEYPRESS( %VS )",
											 "KEYPRESSED( %VS )",
											 "TEST %VS = %VS",
											 "TEST %VS > %VS",

											 "TEST %VS >= %VS",
											 "TEST %VS < %VS",
											 "TEST %VS <= %VS",
											 "FIND_SUBSTRING( %VS , %VS )",
							
											 "INVINCIBLE",
											 "INLADDER",
											 "H_COLLISION( %VS , %VS )",
											 "H_COLLISION_WITH_OBJECT( %VS , %VS , %VS , %CS )",

											 "H_INSIDE_ROOM( %VS , %VS )",
											 "H_PARTIALLY_INSIDE_ROOM( %VS , %VS )",
											 "LOADGAME( %VS )",
											 "SAVEGAME( %VS )"};
*/

BViewConditionScriptWnd::BViewConditionScriptWnd(int x,int y,int dx,int dy,ConditionSCRIPT *s,OBJECT *o,ROOM *r,MAP *m,MOG2 *g,INTERFACE *interfp,EDITOR *e,int lvl,TTF_Font *font) : BWindow(x,y,dx,dy,font)
{
	editor=e;
	script=s;
	object=o;
	room=r;
	map=m;
	game=g;
	interf=interfp;
	level=lvl;
	vwnd=new BViewValueScriptWnd(x,y,dx,dy,0,o,r,m,g,interf,e,level,font);
} /* BViewConditionScriptWnd::BViewConditionScriptWnd */ 


BViewConditionScriptWnd::~BViewConditionScriptWnd()
{
	delete vwnd;
} /* BViewConditionScriptWnd::~BViewConditionScriptWnd */ 


bool BViewConditionScriptWnd::cycle(int stx,int sty)
{
	BWindow::cycle(stx,sty);
	vwnd->local_mouse_x=local_mouse_x;
	vwnd->local_mouse_y=local_mouse_y;
	vwnd->old_stx=old_stx;
	vwnd->old_sty=old_sty;

	if (local_mouse_x>old_stx &&
		local_mouse_y>old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy &&
		mouse_button&SDL_BUTTON(1) &&
		!(old_mouse_button&SDL_BUTTON(1))) {
		click_on_condition_script();
		script->simplify();
		recompute_sizes(script);
		dirty=true;
	} /* if */ 


	if (local_mouse_x>old_stx &&
		local_mouse_y>old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy &&
		mouse_button&SDL_BUTTON(3) &&
		!(old_mouse_button&SDL_BUTTON(3))) {
		right_click_on_condition_script();
		script->simplify();
		recompute_sizes(script);
		dirty=true;
	} /* if */ 


	return true;
} /* BViewConditionScriptWnd::cycle */ 


void BViewConditionScriptWnd::contens_size(int *dx,int *dy)
{
	int max_x=0;
	int max_y=0;

	condition_script_size(script,&max_x,&max_y);

	*dx=old_dx;
	*dy=old_dy;

	if (max_x+8>*dx) *dx=max_x+8;
	if (max_y+8>*dy) *dy=max_y+8;

} /* BViewConditionScriptWnd::contens_size */ 


void BViewConditionScriptWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{

	SDL_FillRect(sfc,0,0);

	selected_script=0;
	vwnd->selected_script=0;

	draw_condition_script(sfc,script,4-stx,4-sty);

	if (vwnd->selected_script!=0) {
		draw_rectangle(sfc,vwnd->selected.x,vwnd->selected.y,vwnd->selected.w,vwnd->selected.h,0xffffff);
	} else {
		if (selected_script!=0) draw_rectangle(sfc,selected.x,selected.y,selected.w,selected.h,0xffffff);
	} /* if */ 

	set_dirty();

} /* BViewConditionScriptWnd::draw_contens */ 


void BViewConditionScriptWnd::draw_condition_script(SDL_Surface *sfc,ConditionSCRIPT *script,int stx,int sty)
{
	int i;
	int dx,dy;
	SDL_Rect r;
	char *pattern;

	condition_script_size(script,&dx,&dy);
	r.x=stx;
	r.y=sty;
	r.w=dx+4;
	r.h=dy+4;
	if (local_mouse_x>=stx+old_stx && local_mouse_y>=sty+old_sty &&
		local_mouse_x<stx+dx+4+old_stx && local_mouse_y<sty+dy+4+old_sty) {
		selected.x=stx;
		selected.y=sty;
		selected.w=dx+4;
		selected.h=dy+4;
		selected_script=script;
	} /* if */ 
	SDL_FillRect(sfc,&r,0xA000A0);
	draw_rectangle(sfc,r.x,r.y,r.w,r.h,0xF000F0);

	pattern=0;
	for(i=0;i<CONDITION_MAX_CMD;i++) {
		if (script->command==condition_cmd_id[i]) pattern=condition_cmd_pat[i];
	} /* for */ 

	if (pattern!=0) {
		int vcount=0;
		int ccount=0;
		int x,y;
		int offset=0;
		char token[256];

		x=stx+2;
		y=sty+2;
		while(offset<int(strlen(pattern)) &&
			  1==sscanf(pattern+offset,"%s",token)) {
			offset+=strlen(token)+1;

			if (strcmp(token,"%VS")==0) {
				int dx2,dy2;

				vwnd->script_size(script->vpar[vcount],&dx2,&dy2);
				vwnd->draw_script(sfc,script->vpar[vcount],x,y);

				vcount++;
				x+=dx2+4+TTF_FontHeight(font);
			} else if(strcmp(token,"%CS")==0) {
				int dx2,dy2;

				condition_script_size(script->aparlist[ccount],&dx2,&dy2);
				draw_condition_script(sfc,script->aparlist[ccount],x,y);

				ccount++;
				x+=dx2+4+TTF_FontHeight(font);
			} else if(strcmp(token,"%L")==0) {
				int dx2,dy2;

				while(ccount<script->aparlist.Length()) {
					condition_script_size(script->aparlist[ccount],&dx2,&dy2);
					draw_condition_script(sfc,script->aparlist[ccount],x,y);
					ccount++;
					y+=dy2+5;
				} /* while */ 
			} else {
				print_left(token,font,255,255,255,sfc,x,y);
				x+=get_text_width(token,font)+TTF_FontHeight(font);
			} /* if */ 
		} /* while */ 
	} /* if */ 

} /* BViewConditionScriptWnd::draw_condition_script */ 


bool BViewConditionScriptWnd::click_on_condition_script(void)
{

	if (vwnd->selected_script!=0) {
		return vwnd->click_on_script();
	} else {
		if (selected_script!=0) {
			int res;
			BVChoiceDlg *dlg;

			/* OBJECT SCRIPTS: */ 
			if (level==0) {
				dlg=new BVChoiceDlg(-1,-1,0,0,"Choose command:","true\nfalse\nnot\nand\nor\ntimmer\ncollision\n"
																  "collision_with_object\ninside_room\n"
																  "partially_inside_room\nsense_object\n"
																  "sense_specific_object\n"
																  "keypress\nkeypressed\neq\ngr\ngreq\n"
																  "lw\nlweq\nfind_substring\n"
																  "invincible\ninladder\n"
																  "h_collision\nh_collision_with_object\n"
																  "h_inside_room\nh_partially_inside_room",&res,font);
				dlg->Execute();
				delete dlg;

				switch(res) {
				case 1:selected_script->command=CONDITION_CMD_TRUE;
					break;
				case 2:selected_script->command=CONDITION_CMD_FALSE;
					break;

				case 3:selected_script->aparlist.Delete();
					   selected_script->aparlist.Add(new ConditionSCRIPT());
					   selected_script->command=CONDITION_CMD_NOT;
					break;
				case 4:if (selected_script->command!=CONDITION_CMD_OR &&
						   selected_script->command!=CONDITION_CMD_AND) {
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						   selected_script->aparlist.Add(new ConditionSCRIPT());
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_AND;
					break;
				case 5:if (selected_script->command!=CONDITION_CMD_OR &&
						   selected_script->command!=CONDITION_CMD_AND) {
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						   selected_script->aparlist.Add(new ConditionSCRIPT());
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_OR;
					break;

				case 6:selected_script->command=CONDITION_CMD_TIMMER;
					   delete selected_script->vpar[0];
					   selected_script->vpar[0]=new ValueSCRIPT();
					break;
				case 7:if (selected_script->command!=CONDITION_CMD_COLLISION &&
						   selected_script->command!=CONDITION_CMD_H_COLLISION) {
						   delete selected_script->vpar[0];
						   delete selected_script->vpar[1];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_COLLISION;
					break;
				case 8:if (selected_script->command!=CONDITION_CMD_COLLISION_WITH_OBJECT &&
						   selected_script->command!=CONDITION_CMD_H_COLLISION_WITH_OBJECT) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->command=VALUE_CMD_STRING;
						   selected_script->vpar[0]->spar=new char[5];
						   strcpy(selected_script->vpar[0]->spar,"none");
						   selected_script->vpar[1]=new ValueSCRIPT();
						   selected_script->vpar[2]=new ValueSCRIPT();
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						} /* if */ 
						selected_script->command=CONDITION_CMD_COLLISION_WITH_OBJECT;
					break;
				case 9:if (selected_script->command!=CONDITION_CMD_INSIDE_ROOM &&
						   selected_script->command!=CONDITION_CMD_H_INSIDE_ROOM) {
						   delete selected_script->vpar[0];
						   delete selected_script->vpar[1];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[1]=new ValueSCRIPT();
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_INSIDE_ROOM;				 
					break;
				case 10:if (selected_script->command!=CONDITION_CMD_PARTIALLY_INSIDE_ROOM &&
							selected_script->command!=CONDITION_CMD_H_PARTIALLY_INSIDE_ROOM) {
						   delete selected_script->vpar[0];
						   delete selected_script->vpar[1];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
					   selected_script->command=CONDITION_CMD_PARTIALLY_INSIDE_ROOM;
					break;

				case 11:selected_script->command=CONDITION_CMD_SENSE_OBJECT;
					   delete selected_script->vpar[0];
					   delete selected_script->vpar[1];
					   delete selected_script->vpar[2];
					   delete selected_script->vpar[3];
					   delete selected_script->vpar[4];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[5];
					   strcpy(selected_script->vpar[0]->spar,"none");
					   selected_script->vpar[1]=new ValueSCRIPT();
					   selected_script->vpar[2]=new ValueSCRIPT();
					   selected_script->vpar[3]=new ValueSCRIPT();
					   selected_script->vpar[4]=new ValueSCRIPT();
					   selected_script->aparlist.Delete();
					   selected_script->aparlist.Add(new ConditionSCRIPT());
					break;

				case 12:selected_script->command=CONDITION_CMD_SENSE_SPECIFIC_OBJECT;
					   delete selected_script->vpar[0];
					   delete selected_script->vpar[1];
					   delete selected_script->vpar[2];
					   delete selected_script->vpar[3];
					   delete selected_script->vpar[4];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[5];
					   strcpy(selected_script->vpar[0]->spar,"none");
					   selected_script->vpar[1]=new ValueSCRIPT();
					   selected_script->vpar[2]=new ValueSCRIPT();
					   selected_script->vpar[3]=new ValueSCRIPT();					   
					   selected_script->vpar[4]=new ValueSCRIPT();
					   selected_script->aparlist.Delete();
					   selected_script->aparlist.Add(new ConditionSCRIPT());
					break;

				case 13:if (selected_script->command!=CONDITION_CMD_KEYPRESS &&
						   selected_script->command!=CONDITION_CMD_KEYPRESSED) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->ipar=0;
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_KEYPRESS;			   
					break;
				case 14:if (selected_script->command!=CONDITION_CMD_KEYPRESS &&
							selected_script->command!=CONDITION_CMD_KEYPRESSED) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->ipar=0;
						} /* if */ 
						selected_script->command=CONDITION_CMD_KEYPRESSED;
					break;

				case 15:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_EQ;
						
					break;
				case 16:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_GR;
						
					break;
				case 17:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_GREQ;
						
					break;
				case 18:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_LW;
					break;

				case 19:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_LWEQ;
					break;

				case 20:selected_script->command=CONDITION_CMD_FIND_SUBSTRING;
					   delete selected_script->vpar[0];
					   delete selected_script->vpar[1];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[1]=new ValueSCRIPT();
					break;

				case 21:selected_script->command=CONDITION_CMD_INVINCIBLE;
					break;

				case 22:selected_script->command=CONDITION_CMD_INLADDER;
					break;

				case 23:if (selected_script->command!=CONDITION_CMD_COLLISION &&
							selected_script->command!=CONDITION_CMD_H_COLLISION) {
						   delete selected_script->vpar[0];
						   delete selected_script->vpar[1];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_H_COLLISION;				
					break;
				case 24:if (selected_script->command!=CONDITION_CMD_COLLISION_WITH_OBJECT &&
							selected_script->command!=CONDITION_CMD_H_COLLISION_WITH_OBJECT) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->command=VALUE_CMD_STRING;
						   selected_script->vpar[0]->spar=new char[5];
						   strcpy(selected_script->vpar[0]->spar,"none");
						   selected_script->vpar[1]=new ValueSCRIPT();
						   selected_script->vpar[2]=new ValueSCRIPT();
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						} /* if */ 
					   selected_script->command=CONDITION_CMD_H_COLLISION_WITH_OBJECT;				   
					break;
				case 25:if (selected_script->command!=CONDITION_CMD_INSIDE_ROOM &&
							selected_script->command!=CONDITION_CMD_H_INSIDE_ROOM) {
						   delete selected_script->vpar[0];
						   delete selected_script->vpar[1];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_H_INSIDE_ROOM;
					break;
				case 26:if (selected_script->command!=CONDITION_CMD_PARTIALLY_INSIDE_ROOM &&
							selected_script->command!=CONDITION_CMD_H_PARTIALLY_INSIDE_ROOM) {
						   delete selected_script->vpar[0];
						   delete selected_script->vpar[1];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
					   selected_script->command=CONDITION_CMD_H_PARTIALLY_INSIDE_ROOM;
					break;

				} /* switch */ 
				return true;
			} /* if */ 


			/* ROOM/INTERFACE SCRIPTS: */ 
			if (level==1 || level==4) {
				if (level==4) {
					dlg=new BVChoiceDlg(-1,-1,0,0,"Choose command:","true\nfalse\nnot\nand\nor\ntimmer\n"
																	  "sense_object\n"
																	  "sense_specific_object\n"
																	  "keypress\nkeypressed\neq\ngr\ngreq\n"
																	  "lw\nlweq\nfind_substring\n"
																	  "loadgame\nsavegame\n",&res,font);
				} else {
					dlg=new BVChoiceDlg(-1,-1,0,0,"Choose command:","true\nfalse\nnot\nand\nor\ntimmer\n"
																	  "sense_object\n"
																	  "sense_specific_object\n"
																	  "keypress\nkeypressed\neq\ngr\ngreq\n"
																	  "lw\nlweq\nfind_substring\n",&res,font);
				} /* if */ 
				dlg->Execute();
				delete dlg;

				switch(res) {
				case 1:selected_script->command=CONDITION_CMD_TRUE;
					break;
				case 2:selected_script->command=CONDITION_CMD_FALSE;
					break;

				case 3:selected_script->aparlist.Delete();
					   selected_script->aparlist.Add(new ConditionSCRIPT());
					   selected_script->command=CONDITION_CMD_NOT;
					break;
				case 4:if (selected_script->command!=CONDITION_CMD_OR &&
						   selected_script->command!=CONDITION_CMD_AND) {
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						   selected_script->aparlist.Add(new ConditionSCRIPT());
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_AND;
					break;
				case 5:if (selected_script->command!=CONDITION_CMD_OR &&
						   selected_script->command!=CONDITION_CMD_AND) {
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						   selected_script->aparlist.Add(new ConditionSCRIPT());
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_OR;
					break;

				case 6:selected_script->command=CONDITION_CMD_TIMMER;
					   delete selected_script->vpar[0];
					   selected_script->vpar[0]=new ValueSCRIPT();
					break;

				case 7:selected_script->command=CONDITION_CMD_SENSE_OBJECT;
					   delete selected_script->vpar[0];
					   delete selected_script->vpar[1];
					   delete selected_script->vpar[2];
					   delete selected_script->vpar[3];
					   delete selected_script->vpar[4];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[5];
					   strcpy(selected_script->vpar[0]->spar,"none");
					   selected_script->vpar[1]=new ValueSCRIPT();
					   selected_script->vpar[2]=new ValueSCRIPT();
					   selected_script->vpar[3]=new ValueSCRIPT();
					   selected_script->vpar[4]=new ValueSCRIPT();
					   selected_script->aparlist.Delete();
					   selected_script->aparlist.Add(new ConditionSCRIPT());
					break;

				case 8:selected_script->command=CONDITION_CMD_SENSE_SPECIFIC_OBJECT;
					   delete selected_script->vpar[0];
					   delete selected_script->vpar[1];
					   delete selected_script->vpar[2];
					   delete selected_script->vpar[3];
					   delete selected_script->vpar[4];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[5];
					   strcpy(selected_script->vpar[0]->spar,"none");
					   selected_script->vpar[1]=new ValueSCRIPT();
					   selected_script->vpar[2]=new ValueSCRIPT();
					   selected_script->vpar[3]=new ValueSCRIPT();
					   selected_script->vpar[4]=new ValueSCRIPT();
					   selected_script->aparlist.Delete();
					   selected_script->aparlist.Add(new ConditionSCRIPT());
					break;

				case 9:if (selected_script->command!=CONDITION_CMD_KEYPRESS &&
						   selected_script->command!=CONDITION_CMD_KEYPRESSED) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->ipar=0;
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_KEYPRESS;			   
					break;
				case 10:if (selected_script->command!=CONDITION_CMD_KEYPRESS &&
							selected_script->command!=CONDITION_CMD_KEYPRESSED) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->ipar=0;
						} /* if */ 
						selected_script->command=CONDITION_CMD_KEYPRESSED;
					break;

				case 11:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_EQ;
						
					break;
				case 12:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_GR;
						
					break;
				case 13:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_GREQ;
						
					break;
				case 14:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_LW;
					break;

				case 15:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_LWEQ;
					break;

				case 16:selected_script->command=CONDITION_CMD_FIND_SUBSTRING;
					   delete selected_script->vpar[0];
					   delete selected_script->vpar[1];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[1]=new ValueSCRIPT();
					break;

				case 17:selected_script->command=CONDITION_CMD_LOADGAME;
					   delete selected_script->vpar[0];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[13];
					   strcpy(selected_script->vpar[0]->spar,"savegame.sav");
					break;
				case 18:selected_script->command=CONDITION_CMD_SAVEGAME;
					   delete selected_script->vpar[0];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[13];
					   strcpy(selected_script->vpar[0]->spar,"savegame.sav");
					break;
				} /* switch */ 
				return true;
			} /* if */ 


			/* MAP/GAME/APPLICATION SCRIPTS: */ 
			if (level==2 || level==3 || level==5) {
				if (level==5) {
					dlg=new BVChoiceDlg(-1,-1,0,0,"Choose command:","true\nfalse\nnot\nand\nor\ntimmer\n"
																	  "keypress\nkeypressed\neq\ngr\ngreq\n"
																	  "lw\nlweq\nfind_substring\n"
																	  "loadgame\nsavegame\n",&res,font);
				} else {
					dlg=new BVChoiceDlg(-1,-1,0,0,"Choose command:","true\nfalse\nnot\nand\nor\ntimmer\n"
																	  "keypress\nkeypressed\neq\ngr\ngreq\n"
																	  "lw\nlweq\nfind_substring\n",&res,font);
				} /* if */ 
				dlg->Execute();
				delete dlg;

				switch(res) {
				case 1:selected_script->command=CONDITION_CMD_TRUE;
					break;
				case 2:selected_script->command=CONDITION_CMD_FALSE;
					break;

				case 3:selected_script->aparlist.Delete();
					   selected_script->aparlist.Add(new ConditionSCRIPT());
					   selected_script->command=CONDITION_CMD_NOT;
					break;
				case 4:if (selected_script->command!=CONDITION_CMD_OR &&
						   selected_script->command!=CONDITION_CMD_AND) {
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						   selected_script->aparlist.Add(new ConditionSCRIPT());
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_AND;
					break;
				case 5:if (selected_script->command!=CONDITION_CMD_OR &&
						   selected_script->command!=CONDITION_CMD_AND) {
						   selected_script->aparlist.Delete();
						   selected_script->aparlist.Add(new ConditionSCRIPT());
						   selected_script->aparlist.Add(new ConditionSCRIPT());
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_OR;
					break;

				case 6:selected_script->command=CONDITION_CMD_TIMMER;
					   delete selected_script->vpar[0];
					   selected_script->vpar[0]=new ValueSCRIPT();
					break;

				case 7:if (selected_script->command!=CONDITION_CMD_KEYPRESS &&
						   selected_script->command!=CONDITION_CMD_KEYPRESSED) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->ipar=0;
					   } /* if */ 
					   selected_script->command=CONDITION_CMD_KEYPRESS;			   
					break;
				case 8:if (selected_script->command!=CONDITION_CMD_KEYPRESS &&
							selected_script->command!=CONDITION_CMD_KEYPRESSED) {
						   delete selected_script->vpar[0];
						   selected_script->vpar[0]=new ValueSCRIPT();
						   selected_script->vpar[0]->ipar=0;
						} /* if */ 
						selected_script->command=CONDITION_CMD_KEYPRESSED;
					break;

				case 9:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_EQ;
						
					break;
				case 10:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_GR;
						
					break;
				case 11:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_GREQ;
						
					break;
				case 12:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_LW;
					break;

				case 13:if (selected_script->command!=CONDITION_CMD_VARIABLE_EQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GR &&
							selected_script->command!=CONDITION_CMD_VARIABLE_GREQ &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LW &&
							selected_script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
							selected_script->vpar[0]=new ValueSCRIPT();
							selected_script->vpar[1]=new ValueSCRIPT();
						} /* if */ 
						selected_script->command=CONDITION_CMD_VARIABLE_LWEQ;
					break;

				case 14:selected_script->command=CONDITION_CMD_FIND_SUBSTRING;
					   delete selected_script->vpar[0];
					   delete selected_script->vpar[1];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[1]=new ValueSCRIPT();
					break;

				case 15:selected_script->command=CONDITION_CMD_LOADGAME;
					   delete selected_script->vpar[0];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[13];
					   strcpy(selected_script->vpar[0]->spar,"savegame.sav");
					break;
				case 16:selected_script->command=CONDITION_CMD_SAVEGAME;
					   delete selected_script->vpar[0];
					   selected_script->vpar[0]=new ValueSCRIPT();
					   selected_script->vpar[0]->command=VALUE_CMD_STRING;
					   selected_script->vpar[0]->spar=new char[13];
					   strcpy(selected_script->vpar[0]->spar,"savegame.sav");
					break;

				} /* switch */ 
				return true;
			} /* if */ 



		} /* if */ 
	} /* if */ 

	return false;
} /* BViewConditionScriptWnd::click_on_condition_script */ 


bool BViewConditionScriptWnd::right_click_on_condition_script(void)
{

	if (vwnd->selected_script!=0) {
		return vwnd->right_click_on_script();
	} else {
		if (selected_script!=0) {
			int res;
			BVChoiceDlg *dlg;

			dlg=new BVChoiceDlg(-1,-1,0,0,"Operation:","Delete\nAnd after\nAnd before\nOr after\nOr before\nNegate\ncopy\ncut\npaste\n",&res,font);
			dlg->Execute();
			delete dlg;

			if (res==1) {
				selected_script->aparlist.Delete();
				selected_script->command=CONDITION_CMD_DELETE;
			} /* if */ 

			if (res==2) {
				ConditionSCRIPT *tmp=new ConditionSCRIPT(*selected_script);
				selected_script->aparlist.Delete();
				selected_script->aparlist.Add(tmp);
				selected_script->aparlist.Add(new ConditionSCRIPT());
				selected_script->command=CONDITION_CMD_AND;
			} /* uf */ 
			if (res==3) {
				ConditionSCRIPT *tmp=new ConditionSCRIPT(*selected_script);
				selected_script->aparlist.Delete();
				selected_script->aparlist.Add(new ConditionSCRIPT());
				selected_script->aparlist.Add(tmp);
				selected_script->command=CONDITION_CMD_AND;
			} /* if */ 

			if (res==4) {
				ConditionSCRIPT *tmp=new ConditionSCRIPT(*selected_script);
				selected_script->aparlist.Delete();
				selected_script->aparlist.Add(tmp);
				selected_script->aparlist.Add(new ConditionSCRIPT());
				selected_script->command=CONDITION_CMD_OR;
			} /* if */ 
			if (res==5) {
				ConditionSCRIPT *tmp=new ConditionSCRIPT(*selected_script);
				selected_script->aparlist.Delete();
				selected_script->aparlist.Add(new ConditionSCRIPT());
				selected_script->aparlist.Add(tmp);
				selected_script->command=CONDITION_CMD_OR;
			} /* if */ 

			if (res==6) {
				ConditionSCRIPT *tmp;
				tmp=new ConditionSCRIPT(*selected_script);

				selected_script->aparlist.Delete();
				selected_script->aparlist.Add(tmp);
				selected_script->command=CONDITION_CMD_NOT;
			} /* if */ 

			if (res==7) {
				/* COPY */ 
				editor->se_clipboard_content=3;
				if (editor->se_clipboard_condition!=0) delete editor->se_clipboard_condition;
				editor->se_clipboard_condition=new ConditionSCRIPT(*selected_script);
			} /* if */ 

			if (res==8) {
				/* CUT */ 
				editor->se_clipboard_content=3;
				if (editor->se_clipboard_condition!=0) delete editor->se_clipboard_condition;
				editor->se_clipboard_condition=new ConditionSCRIPT(*selected_script);
				selected_script->command=CONDITION_CMD_DELETE;
			} /* if */ 

			if (res==9) {
				/* PASTE */ 
				if (editor->se_clipboard_content==3) {
					selected_script->copy_state(editor->se_clipboard_condition);
				} else {
					BChoiceDlg *dlg2=new BChoiceDlg(40,40,250,50,"The clipboard doesn't contain an action","Accept",&res,editor->font);
					dlg2->Execute();
					delete dlg2;
				} /* if */ 
			} /* if */ 

			return true;
		} /* if */ 
	} /* if */ 

	return false;
} /* BViewConditionScriptWnd::right_click_on_condition_script */ 


void BViewConditionScriptWnd::condition_script_size(ConditionSCRIPT *script,int *dx,int *dy)
{
	int i;
	char *pattern;

	if (script->dx!=0 &&
		script->dy!=0) {
		*dx=script->dx;
		*dy=script->dy;
		return;
	} /* if */ 

	*dx=0;
	*dy=0;
	pattern=0;
	for(i=0;i<CONDITION_MAX_CMD;i++) {
		if (script->command==condition_cmd_id[i]) pattern=condition_cmd_pat[i];
	} /* for */ 

	if (pattern!=0) {
		int dx2,dy2;
		int vcount=0;
		int ccount=0;
		int x,y;
		int offset=0;
		char token[256];

		x=0;
		y=0;
		while(offset<int(strlen(pattern)) &&
			  1==sscanf(pattern+offset,"%s",token)) {
			offset+=strlen(token)+1;

			if (strcmp(token,"%VS")==0) {

				vwnd->script_size(script->vpar[vcount],&dx2,&dy2);

				if (dx2+x+4>*dx) *dx=dx2+x+4;
				if (dy2+y+4>*dy) *dy=dy2+y+4;
				vcount++;
				x+=dx2+4+TTF_FontHeight(font);
			} else if(strcmp(token,"%CS")==0) {

				condition_script_size(script->aparlist[ccount],&dx2,&dy2);
				if (dx2+x+4>*dx) *dx=dx2+x+4;
				if (dy2+y+4>*dy) *dy=dy2+y+4;
				ccount++;
				x+=dx2+4+TTF_FontHeight(font);
			} else if(strcmp(token,"%L")==0) {

				while(ccount<script->aparlist.Length()) {
					condition_script_size(script->aparlist[ccount],&dx2,&dy2);
					if (dx2+x+4>*dx) *dx=dx2+x+4;
					if (dy2+y+4>*dy) *dy=dy2+y+4;
					ccount++;
					y+=dy2+5;
				} /* while */ 
			} else {
				dx2=get_text_width(token,font);
				dy2=TTF_FontHeight(font);
				if (dx2+x>*dx) *dx=dx2+x;
				if (dy2+y>*dy) *dy=dy2+y;
				x+=dx2+TTF_FontHeight(font);
			} /* if */ 
		} /* while */ 
	} /* if */ 

	script->dx=*dx;
	script->dy=*dy;
} /* BViewConditionScriptWnd::condition_script_size */ 


void BViewConditionScriptWnd::recompute_sizes(ConditionSCRIPT *script)
{
	int i;
	ConditionSCRIPT *as;
	List<ConditionSCRIPT> l;

	for(i=0;i<MAX_CONDITION_PARAMETERS;i++) {
		if (script->vpar[i]!=0) {
			vwnd->recompute_sizes(script->vpar[i]);
		} /* if */ 
	} /* for */ 

	l.Instance(script->aparlist);
	l.Rewind();
	while(l.Iterate(as)) {
		recompute_sizes(as);
	} /* while */ 
	script->dx=0;
	script->dy=0;
} /* BViewConditionScriptWnd::recompute_sizes */ 


void BViewConditionScriptWnd::save_bmp(char *file)
{
	int dx=0,dy=0;
	SDL_Surface *sfc;

	condition_script_size(script,&dx,&dy);
	sfc=SDL_CreateRGBSurface(SDL_SWSURFACE,dx,dy,32,0,0,0,0);

	draw_condition_script(sfc,script,0,0);

	SDL_SaveBMP(sfc,file);

	SDL_FreeSurface(sfc);
} /* BViewConditionScriptWnd::save_bmp */ 
