#ifdef _WIN32
#include <windows.h>
#include <windowsx.h>
#else
#include <sys/time.h>
#include <time.h>
#endif
#include "assert.h"

#include "stdio.h"
#include "string.h"
#include "math.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"

#include "auxiliar.h"
#include "MOG2_auxiliar.h"

#include "valuescript.h"
#include "conditionscript.h"
#include "actionscript.h"
#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "interfaces.h"
#include "activeobject.h"
#include "activeroom.h"
#include "activeMAP.h"
#include "activemog2.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

extern int surface_flags;


void OBJECT::text_initialization(void)
{
	text_text=0;
	text_font=0;
	text_size=0;
	text_spacing=0;
	text_r=255;
	text_g=255;
	text_b=255;
	text_a=SDL_ALPHA_OPAQUE;
	text_frame=0;
	text_frame_width=0;
	text_frame_r1=text_frame_g1=text_frame_b1=0;
	text_frame_a1=SDL_ALPHA_OPAQUE;
	text_frame_r2=text_frame_g2=text_frame_b2=255;
	text_frame_a2=SDL_ALPHA_OPAQUE;
	text_frame_radius=800;
	text_frame_point_x=0;
	text_frame_point_y=0;
	text_h_align=1;
	text_v_align=2;
	text_max_w=240;
} /* OBJECT::text_initialization */ 


void OBJECT::text_initialization(OBJECT *o)
{
	if(o->text_text!=0) {
		text_text=new char[strlen(o->text_text)+1];
		strcpy(text_text,o->text_text);
	} else {
		text_text=0;
	} /* if */ 
	if(o->text_font!=0) {
		text_font=new char[strlen(o->text_font)+1];
		strcpy(text_font,o->text_font);
	} else {
		text_font=0;
	} /* if */ 
	text_size=o->text_size;
	text_spacing=o->text_spacing;
	text_r=o->text_r;
	text_g=o->text_r;
	text_b=o->text_b;
	text_a=o->text_a;
	text_frame=o->text_frame;
	text_frame_width=o->text_frame_width;
	text_frame_r1=o->text_frame_r1;
	text_frame_g1=o->text_frame_g1;
	text_frame_b1=o->text_frame_b1;
	text_frame_a1=o->text_frame_a1;
	text_frame_r2=o->text_frame_r2;
	text_frame_g2=o->text_frame_g2;
	text_frame_b2=o->text_frame_b2;
	text_frame_a2=o->text_frame_a2;
	text_frame_radius=o->text_frame_radius;
	text_frame_point_x=o->text_frame_point_x;
	text_frame_point_y=o->text_frame_point_y;
	text_h_align=o->text_h_align;
	text_v_align=o->text_v_align;
	text_max_w=o->text_max_w;
} /* OBJECT::text_initialization */ 


void ActiveOBJECT::text_initialization(void)
{
	text_text=0;
	text_font=0;
	text_size=0;
	text_spacing=0;
	text_r=255;
	text_g=255;
	text_b=255;
	text_a=SDL_ALPHA_OPAQUE;
	text_frame=0;
	text_frame_width=0;
	text_frame_r1=text_frame_g1=text_frame_b1=0;
	text_frame_a1=SDL_ALPHA_OPAQUE;
	text_frame_r2=text_frame_g2=text_frame_b2=255;
	text_frame_a2=SDL_ALPHA_OPAQUE;
	text_frame_radius=800;
	text_frame_point_x=0;
	text_frame_point_y=0;
	text_h_align=1;
	text_v_align=2;
	text_max_w=240;
} /* ActiveOBJECT::text_initialization */ 



void ActiveOBJECT::text_initialization(OBJECT *o)
{
	if(o->text_text!=0) {
		text_text=new char[strlen(o->text_text)+1];
		strcpy(text_text,o->text_text);
	} else {
		text_text=0;
	} /* if */ 
	if(o->text_font!=0) {
		text_font=new char[strlen(o->text_font)+1];
		strcpy(text_font,o->text_font);
	} else {
		text_font=0;
	} /* if */ 
	text_size=o->text_size;
	text_spacing=o->text_spacing;
	text_r=o->text_r;
	text_g=o->text_r;
	text_b=o->text_b;
	text_a=o->text_a;
	text_frame=o->text_frame;
	text_frame_width=o->text_frame_width;
	text_frame_r1=o->text_frame_r1;
	text_frame_g1=o->text_frame_g1;
	text_frame_b1=o->text_frame_b1;
	text_frame_a1=o->text_frame_a1;
	text_frame_r2=o->text_frame_r2;
	text_frame_g2=o->text_frame_g2;
	text_frame_b2=o->text_frame_b2;
	text_frame_a2=o->text_frame_a2;
	text_frame_radius=o->text_frame_radius;
	text_frame_point_x=o->text_frame_point_x;
	text_frame_point_y=o->text_frame_point_y;
	text_h_align=o->text_h_align;
	text_v_align=o->text_v_align;
	text_max_w=o->text_max_w;
} /* ActiveOBJECT::text_initialization */ 


void ActiveOBJECT::text_initialization(ActiveOBJECT *o)
{
	if(o->text_text!=0) {
		text_text=new char[strlen(o->text_text)+1];
		strcpy(text_text,o->text_text);
	} else {
		text_text=0;
	} /* if */ 
	if(o->text_font!=0) {
		text_font=new char[strlen(o->text_font)+1];
		strcpy(text_font,o->text_font);
	} else {
		text_font=0;
	} /* if */ 
	text_size=o->text_size;
	text_spacing=o->text_spacing;
	text_r=o->text_r;
	text_g=o->text_r;
	text_b=o->text_b;
	text_a=o->text_a;
	text_frame=o->text_frame;
	text_frame_width=o->text_frame_width;
	text_frame_r1=o->text_frame_r1;
	text_frame_g1=o->text_frame_g1;
	text_frame_b1=o->text_frame_b1;
	text_frame_a1=o->text_frame_a1;
	text_frame_r2=o->text_frame_r2;
	text_frame_g2=o->text_frame_g2;
	text_frame_b2=o->text_frame_b2;
	text_frame_a2=o->text_frame_a2;
	text_frame_radius=o->text_frame_radius;
	text_frame_point_x=o->text_frame_point_x;
	text_frame_point_y=o->text_frame_point_y;
	text_h_align=o->text_h_align;
	text_v_align=o->text_v_align;
	text_max_w=o->text_max_w;
} /* ActiveOBJECT::text_initialization */ 


void ActiveOBJECT::text_draw(int sx,int sy,SDL_Surface *sfc,SDL_Rect *vp)
{
	SDL_Surface *s;
	SDL_Rect r;
	FONTCONTAINER *font=0;
	if (text_font!=0) font=get_game()->active_game->get_font(text_font,text_size);

	s=frame_text_draw(&r,font,
					  text_text,text_spacing,text_max_w,text_frame,
					  text_h_align,text_v_align,text_frame_radius,text_frame_width,
					  text_frame_point_x,text_frame_point_y,
					  text_r,text_g,text_b,text_a,
					  text_frame_r1,text_frame_g1,text_frame_b1,text_frame_a1,
					  text_frame_r2,text_frame_g2,text_frame_b2,text_frame_a2);

	r.x+=short(sx+x);
	r.y+=short(sy+y);

	if (s!=0) {
		switch(dm_drawing_mode) {
		case 0: SDL_BlitSurface(s,0,sfc,&r);
				break;
		case 1:
				{
					SDL_Surface *tmp;
					tmp=SDL_DisplayFormatAlpha(s);
					surface_shader(tmp,float(dm_factor)/100.0F,dm_color1_r,dm_color1_g,dm_color1_b,dm_color1_a,0);
					SDL_BlitSurface(tmp,0,sfc,&r);
					SDL_FreeSurface(tmp);
				}
				break;
		case 2:
				{
					SDL_Surface *tmp;
					tmp=SDL_DisplayFormatAlpha(s);
					surface_bicolor(tmp,float(dm_factor)/100.0F,dm_color1_r,dm_color1_g,dm_color1_b,dm_color1_a,dm_color2_r,dm_color2_g,dm_color2_b,dm_color2_a,0);
					SDL_BlitSurface(tmp,0,sfc,&r);
					SDL_FreeSurface(tmp);
				}
				break;
		case 3:
				SDL_BlitSurface(s,0,sfc,&r);
				break;
		} /* switch */ 
		SDL_FreeSurface(s);
		s=0;
	} /* if */ 


} /* ActiveOBJECT::text_draw */ 




void OBJECT::text_draw(int x,int y,SDL_Surface *sfc,SDL_Rect *vp,MOG2 *game)
{
	SDL_Surface *s;
	SDL_Rect r;
	FONTCONTAINER *font=0;
	
	if (text_font!=0) font=game->get_font(text_font,text_size);
	s=frame_text_draw(&r,font,
					  text_text,text_spacing,text_max_w,text_frame,
					  text_h_align,text_v_align,text_frame_radius,text_frame_width,
					  text_frame_point_x,text_frame_point_y,
					  text_r,text_g,text_b,text_a,
					  text_frame_r1,text_frame_g1,text_frame_b1,text_frame_a1,
					  text_frame_r2,text_frame_g2,text_frame_b2,text_frame_a2);

	r.x+=short(x);
	r.y+=short(y);

	if (s!=0) {
		switch(dm_drawing_mode) {
		case 0: SDL_BlitSurface(s,0,sfc,&r);
				break;
		case 1:
				{
					SDL_Surface *tmp;
					tmp=SDL_DisplayFormatAlpha(s);
					surface_shader(tmp,float(dm_factor)/100.0F,dm_color1_r,dm_color1_g,dm_color1_b,dm_color1_a,0);
					SDL_BlitSurface(tmp,0,sfc,&r);
					SDL_FreeSurface(tmp);
				}
				break;
		case 2:
				{
					SDL_Surface *tmp;
					tmp=SDL_DisplayFormatAlpha(s);
					surface_bicolor(tmp,float(dm_factor)/100.0F,dm_color1_r,dm_color1_g,dm_color1_b,dm_color1_a,dm_color2_r,dm_color2_g,dm_color2_b,dm_color2_a,0);
					SDL_BlitSurface(tmp,0,sfc,&r);
					SDL_FreeSurface(tmp);
				}
				break;
		case 3:
				SDL_BlitSurface(s,0,sfc,&r);
				break;
		} /* switch */ 
		SDL_FreeSurface(s);
		s=0;
	} /* if */ 

} /* OBJECT::text_draw */ 



void OBJECT::get_text_bbox(int x,int y,int *x1,int *y1,int *x2,int *y2,MOG2 *game)
{
	SDL_Rect r;
	FONTCONTAINER *font=0;
	if (text_font!=0) font=game->get_font(text_font,text_size);

	frame_text_bbox(&r,font,
					text_text,text_spacing,text_max_w,text_frame,
					text_h_align,text_v_align,text_frame_radius,text_frame_width,
					text_frame_point_x,text_frame_point_y);

	*x1=r.x+x;
	*y1=r.y+y;
	*x2=r.x+x+r.w;
	*y2=r.y+y+r.h;
	
} /* OBJECT::get_text_bbox */ 



void PLACED_OBJECT::get_text_bbox(int *x1,int *y1,int *x2,int *y2)
{
	SDL_Rect r;
	FONTCONTAINER *font=0;
	char *t_font=object->text_font,*t_text=object->text_text;
	int t_size=object->text_size;
	int t_spacing=object->text_spacing,t_max_w=object->text_max_w,t_frame=object->text_frame;
	int t_h_align=object->text_h_align,t_v_align=object->text_v_align,t_frame_radius=object->text_frame_radius,t_frame_width=object->text_frame_width;
	int t_frame_point_x=object->text_frame_point_x,t_frame_point_y=object->text_frame_point_y;
	
	{
		List<VARIABLE> l;
		VARIABLE *v;

		l.Instance(modified_variables);
		l.Rewind();
		while(l.Iterate(v)) {
			if (v->cmp("text_font")) v->get(0,&t_font,0);
			if (v->cmp("text_text")) v->get(0,&t_text,0);
			if (v->cmp("text_size")) v->get(&t_size,0,0);
			if (v->cmp("text_spacing")) v->get(&t_spacing,0,0);
			if (v->cmp("text_max_w")) v->get(&t_max_w,0,0);
			if (v->cmp("text_frame")) v->get(&t_frame,0,0);
			if (v->cmp("text_h_align")) v->get(&t_h_align,0,0);
			if (v->cmp("text_v_align")) v->get(&t_v_align,0,0);
			if (v->cmp("text_frame_radius")) v->get(&t_frame_radius,0,0);
			if (v->cmp("text_frame_width")) v->get(&t_frame_width,0,0);
			if (v->cmp("text_frame_point_x")) v->get(&t_frame_point_x,0,0);
			if (v->cmp("text_frame_point_y")) v->get(&t_frame_point_y,0,0);
		} /* while */ 
	}

	if (room!=0) {
		if (t_font!=0) font=room->map->game->get_font(t_font,t_size);
	} else {
		if (t_font!=0) font=interf->game->get_font(t_font,t_size);
	} /* if */ 

	frame_text_bbox(&r,font,
					t_text,t_spacing,t_max_w,t_frame,
					t_h_align,t_v_align,t_frame_radius,t_frame_width,
					t_frame_point_x,t_frame_point_y);

	*x1=r.x+x;
	*y1=r.y+y;
	*x2=r.x+x+r.w;
	*y2=r.y+y+r.h;
} /* PLACED_OBJECT::get_text_bbox */ 



void PLACED_OBJECT::text_draw(long int sx,long int sy,SDL_Surface *sfc,SDL_Rect *vp,MOG2 *game)
{
	SDL_Surface *s;
	SDL_Rect r;
	FONTCONTAINER *font=0;
	char *t_font=object->text_font,*t_text=object->text_text;
	int t_size=object->text_size;
	int t_spacing=object->text_spacing,t_max_w=object->text_max_w,t_frame=object->text_frame;
	int t_h_align=object->text_h_align,t_v_align=object->text_v_align,t_frame_radius=object->text_frame_radius,t_frame_width=object->text_frame_width;
	int t_frame_point_x=object->text_frame_point_x,t_frame_point_y=object->text_frame_point_y;

	int t_r=object->text_r,t_g=object->text_g,t_b=object->text_b,t_a=object->text_a;
	int t_frame_r1=object->text_frame_r1,t_frame_g1=object->text_frame_g1,t_frame_b1=object->text_frame_b1,t_frame_a1=object->text_frame_a1;
	int t_frame_r2=object->text_frame_r2,t_frame_g2=object->text_frame_g2,t_frame_b2=object->text_frame_b2,t_frame_a2=object->text_frame_a2;
	
	{
		List<VARIABLE> l;
		VARIABLE *v;

		l.Instance(modified_variables);
		l.Rewind();
		while(l.Iterate(v)) {
			if (v->cmp("text_font")) v->get(0,&t_font,0);
			if (v->cmp("text_text")) v->get(0,&t_text,0);
			if (v->cmp("text_size")) v->get(&t_size,0,0);
			if (v->cmp("text_spacing")) v->get(&t_spacing,0,0);
			if (v->cmp("text_max_w")) v->get(&t_max_w,0,0);
			if (v->cmp("text_frame")) v->get(&t_frame,0,0);
			if (v->cmp("text_h_align")) v->get(&t_h_align,0,0);
			if (v->cmp("text_v_align")) v->get(&t_v_align,0,0);
			if (v->cmp("text_frame_radius")) v->get(&t_frame_radius,0,0);
			if (v->cmp("text_frame_width")) v->get(&t_frame_width,0,0);
			if (v->cmp("text_frame_point_x")) v->get(&t_frame_point_x,0,0);
			if (v->cmp("text_frame_point_y")) v->get(&t_frame_point_y,0,0);

			if (v->cmp("text_r")) v->get(&t_r,0,0);
			if (v->cmp("text_g")) v->get(&t_g,0,0);
			if (v->cmp("text_b")) v->get(&t_b,0,0);
			if (v->cmp("text_a")) v->get(&t_a,0,0);

			if (v->cmp("text_frame_r1")) v->get(&t_frame_r1,0,0);
			if (v->cmp("text_frame_g1")) v->get(&t_frame_g1,0,0);
			if (v->cmp("text_frame_b1")) v->get(&t_frame_b1,0,0);
			if (v->cmp("text_frame_a1")) v->get(&t_frame_a1,0,0);

			if (v->cmp("text_frame_r2")) v->get(&t_frame_r2,0,0);
			if (v->cmp("text_frame_g2")) v->get(&t_frame_g2,0,0);
			if (v->cmp("text_frame_b2")) v->get(&t_frame_b2,0,0);
			if (v->cmp("text_frame_a2")) v->get(&t_frame_a2,0,0);
		} /* while */ 
	}

	if (t_font!=0) font=game->get_font(t_font,t_size);
	s=frame_text_draw(&r,font,
					  t_text,t_spacing,t_max_w,t_frame,
					  t_h_align,t_v_align,t_frame_radius,t_frame_width,
					  t_frame_point_x,t_frame_point_y,
					  t_r,t_g,t_b,t_a,
					  t_frame_r1,t_frame_g1,t_frame_b1,t_frame_a1,
					  t_frame_r2,t_frame_g2,t_frame_b2,t_frame_a2);

	r.x+=short(x+sx);
	r.y+=short(y+sx);

	if (s!=0) {
		switch(object->dm_drawing_mode) {
		case 0: SDL_BlitSurface(s,0,sfc,&r);
				break;
		case 1:
				{
					SDL_Surface *tmp;
					tmp=SDL_DisplayFormatAlpha(s);
					surface_shader(tmp,float(object->dm_factor)/100.0F,object->dm_color1_r,object->dm_color1_g,object->dm_color1_b,object->dm_color1_a,0);
					SDL_BlitSurface(tmp,0,sfc,&r);
					SDL_FreeSurface(tmp);
				}
				break;
		case 2:
				{
					SDL_Surface *tmp;
					tmp=SDL_DisplayFormatAlpha(s);
					surface_bicolor(tmp,float(object->dm_factor)/100.0F,object->dm_color1_r,object->dm_color1_g,object->dm_color1_b,object->dm_color1_a,object->dm_color2_r,object->dm_color2_g,object->dm_color2_b,object->dm_color2_a,0);
					SDL_BlitSurface(tmp,0,sfc,&r);
					SDL_FreeSurface(tmp);
				}
				break;
		case 3:
				SDL_BlitSurface(s,0,sfc,&r);
				break;
		} /* switch */ 
		SDL_FreeSurface(s);
		s=0;
	} /* if */ 

} /* PLACED_OBJECT::text_draw */ 