#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"
#include "auxiliar.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BVChoiceDlg.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BVChoiceDlg::BVChoiceDlg(int x,int y,int dx,int dy,char *q,char *butts,int *r,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int i=0,j=0,id=1;
	char tmp[80];
	int but_y=20;
	int but_dx;
	int max_dx=0;

	for(i=0,j=0;butts[i]!=0;i++) {
		if (butts[i]=='\n') {
			tmp[j]=0;

			but_dx=get_text_width(tmp,font)+10;
			b=new BButton(20,but_y,but_dx,12,tmp,id++);
			buttons.Add(b);
			but_y+=14;

			if (but_dx>max_dx) max_dx=but_dx;

			j=0;
		} else {
			tmp[j++]=butts[i];
		} /* if */ 	
	} /* for */ 

	b=new BButton(20,but_y,get_text_width("CANCEL",font)+10,12,"CANCEL",0);
	buttons.Add(b);
	but_y+=14;
	if (get_text_width("CANCEL",font)+10>max_dx) max_dx=get_text_width("CANCEL",font)+10;
	max_dx+=40;

	if (get_text_width(q,font)+10>max_dx) max_dx=get_text_width(q,font)+10;

	if (dx==0) old_dx=max_dx;
	if (dy==0) old_dy=but_y;

	if (x==-1 || y==-1) {
		new_window_coordinates(old_dx,old_dy,&old_x,&old_y);
	} /* if */ 

	query=q;
	result=r;
} /* BVChoiceDlg::BVChoiceDlg */ 


BVChoiceDlg::~BVChoiceDlg()
{
} /* BVChoiceDlg::BVChoiceDlg */ 


void BVChoiceDlg::contens_size(int *dx,int *dy)
{
	BWindow::contens_size(dx,dy);

	if (old_dx>*dx) *dx=old_dx;
	if (old_dy>*dy) *dy=old_dy;
} /* BVChoiceDlg::contens_size */ 


void BVChoiceDlg::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	print_centered(query,font,255,255,255,sfc,sfc->w/2-stx,8-sty);
} /* BVChoiceDlg::draw_contens */ 


bool BVChoiceDlg::button_pressed(int ID)
{
	*result=ID;
	return false;
} /* BVChoiceDlg::button_pressed */ 


