#include "string.h"

#include "SDL/SDL.h"
#include "fonts.h"
#include "list.h"

#include "BWindow.h"

#include "valuescript.h"
#include "conditionscript.h"
#include "actionscript.h"

#include "BActiveWindow.h"
#include "BIntegerEdDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"
#include "TileViewWnd.h"
#include "TileSelectionWnd.h"
#include "ValueScriptWnd.h"
#include "ConditionScriptWnd.h"

extern int SCREEN_X,SCREEN_Y;

BViewConditionScriptWnd::BViewConditionScriptWnd(int x,int y,int dx,int dy,ConditionSCRIPT *s,OBJECT *o,EDITOR *e,BMP_FONT *font) : BWindow(x,y,dx,dy,font)
{
	script=s;
	object=o;
	vwnd=new BViewValueScriptWnd(x,y,dx,dy,0,o,e,font);
} /* BViewConditionScriptWnd::BViewConditionScriptWnd */ 


BViewConditionScriptWnd::~BViewConditionScriptWnd()
{
	delete vwnd;
} /* BViewConditionScriptWnd::~BViewConditionScriptWnd */ 


bool BViewConditionScriptWnd::cycle(int stx,int sty)
{
	BWindow::cycle(stx,sty);
	vwnd->local_mouse_x=local_mouse_x;
	vwnd->local_mouse_y=local_mouse_y;

	if (local_mouse_x>old_stx &&
		local_mouse_y>old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy &&
		mouse_button&SDL_BUTTON(1) &&
		!(old_mouse_button&SDL_BUTTON(1))) {
		click_on_condition_script(script,4,4);
		script->simplify();
		dirty=true;
	} /* if */ 


	if (local_mouse_x>old_stx &&
		local_mouse_y>old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy &&
		mouse_button&SDL_BUTTON(3) &&
		!(old_mouse_button&SDL_BUTTON(3))) {
		int operation=0;
		right_click_on_condition_script(script,4,4);
		script->simplify();
		dirty=true;
	} /* if */ 


	return true;
} /* BViewConditionScriptWnd::cycle */ 


void BViewConditionScriptWnd::contens_size(int *dx,int *dy)
{
	int max_x=0;
	int max_y=0;

	condition_script_size(script,&max_x,&max_y);

	*dx=old_dx;
	*dy=old_dy;

	if (max_x+8>*dx) *dx=max_x+8;
	if (max_y+8>*dy) *dy=max_y+8;

} /* BViewConditionScriptWnd::contens_size */ 


void BViewConditionScriptWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{

	SDL_FillRect(sfc,0,0);

	draw_condition_script(sfc,script,4-stx,4-sty);

} /* BViewConditionScriptWnd::draw_contens */ 


void BViewConditionScriptWnd::draw_condition_script(SDL_Surface *sfc,ConditionSCRIPT *script,int stx,int sty)
{
	int dx,dy;
	SDL_Rect r;
	char tmp[256];

	condition_script_size(script,&dx,&dy);
	r.x=stx;
	r.y=sty;
	r.w=dx+4;
	r.h=dy+4;
	SDL_FillRect(sfc,&r,0xF000F0);
	r.x=stx+1;
	r.y=sty+1;
	r.w=dx+2;
	r.h=dy+2;
	SDL_FillRect(sfc,&r,0xA000A0);

	switch(script->command) {

	case CONDITION_CMD_TRUE:
		font->print(stx+2,sty+2,"TRUE",sfc);
		break;
	case CONDITION_CMD_FALSE:
		font->print(stx+2,sty+2,"FALSE",sfc);
		break;

	case CONDITION_CMD_NOT:
		{
			int x,y;
			int dx2,dy2;

			x=stx+int(strlen("NOT ( ")*font->get_dx());
			y=sty+2;

			condition_script_size(script->aparlist[0],&dx2,&dy2);
			draw_condition_script(sfc,script->aparlist[0],x,y);

			sprintf(tmp,"NOT ( ");
			font->print(stx+2,sty+4,tmp,sfc);
			font->print(x+dx2+2,sty+4," )",sfc);
		}
		break;
	case CONDITION_CMD_AND:
		{
			List<ConditionSCRIPT> l;
			ConditionSCRIPT *as;
			int x,y;

			x=stx+int(strlen("AND ( ")*font->get_dx());
			y=sty+2;
			l.Instance(script->aparlist);
			l.Rewind();
			while(l.Iterate(as)) {
				int dx2,dy2;

				condition_script_size(as,&dx2,&dy2);
				draw_condition_script(sfc,as,x,y);
				y+=dy2+6;
			} /* while */ 

			r.x=x;
			r.y=y;
			r.w=3*font->get_dx()+4;
			r.h=font->get_dy()+4;
			SDL_FillRect(sfc,&r,0x00A000);

			sprintf(tmp,"AND ( ");
			font->print(stx+2,sty+4,tmp,sfc);
			font->print(x+2,y+2,"END )",sfc);
		}
		break;
	case CONDITION_CMD_OR:
		{
			List<ConditionSCRIPT> l;
			ConditionSCRIPT *as;
			int x,y;

			x=stx+int(strlen("OR ( ")*font->get_dx());
			y=sty+2;
			l.Instance(script->aparlist);
			l.Rewind();
			while(l.Iterate(as)) {
				int dx2,dy2;

				condition_script_size(as,&dx2,&dy2);
				draw_condition_script(sfc,as,x,y);
				y+=dy2+6;
			} /* while */ 

			r.x=x;
			r.y=y;
			r.w=3*font->get_dx()+4;
			r.h=font->get_dy()+4;
			SDL_FillRect(sfc,&r,0x00A000);

			sprintf(tmp,"OR ( ");
			font->print(stx+2,sty+4,tmp,sfc);
			font->print(x+2,y+2,"END )",sfc);
		}
		break;

	case CONDITION_CMD_TIMMER:
		{
			int x,y;
			int dx2,dy2;

			x=stx+int(strlen("TIMMER ( ")*font->get_dx());
			y=sty+2;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x,y);
			y+=dy2+6;

			font->print(stx+2,sty+4,"TIMMER ( ",sfc);
			font->print(x+dx2+6,sty+4," )",sfc);
		}
		break;
	case CONDITION_CMD_COLLISION:
		{
			int x;
			int dx2,dy2;
			int dx3,dy3;

			x=stx+int(strlen("COLLISION ( ")*font->get_dx());

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,sty+2);

			vwnd->script_size(script->vpar2,&dx3,&dy3);
			vwnd->draw_script(sfc,script->vpar2,x+dx2+6+3*font->get_dx(),sty+2);

			font->print(stx+2,sty+4,"COLLISION ( ",sfc);
			font->print(x+dx2+6,sty+4," , ",sfc);
			font->print(x+dx2+dx3+10+3*font->get_dx(),sty+4," ) ",sfc);
		}
		break;
	case CONDITION_CMD_INSIDE_ROOM:
		{
			int x;
			int dx2,dy2;
			int dx3,dy3;

			x=stx+int(strlen("INSIDE_ROOM ( ")*font->get_dx());

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,sty+2);

			vwnd->script_size(script->vpar2,&dx3,&dy3);
			vwnd->draw_script(sfc,script->vpar2,x+dx2+6+3*font->get_dx(),sty+2);

			font->print(stx+2,sty+4,"INSIDE_ROOM ( ",sfc);
			font->print(x+dx2+6,sty+4," , ",sfc);
			font->print(x+dx2+dx3+10+3*font->get_dx(),sty+4," ) ",sfc);
		}
		break;

	case CONDITION_CMD_KEYPRESS:
		{
			int x,y;
			int dx2,dy2;

			x=stx+int(strlen("KEYPRESS ( ")*font->get_dx());
			y=sty+2;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,y);
			y+=dy2+6;

			font->print(stx+2,sty+4,"KEYPRESS ( ",sfc);
			font->print(x+dx2+6,sty+4," )",sfc);
		}
		break;
	case CONDITION_CMD_KEYPRESSED:
		{
			int x,y;
			int dx2,dy2;

			x=stx+int(strlen("KEYPRESSED ( ")*font->get_dx());
			y=sty+2;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,y);
			y+=dy2+6;

			font->print(stx+2,sty+4,"KEYPRESSED ( ",sfc);
			font->print(x+dx2+6,sty+4," )",sfc);
		}
		break;

	case CONDITION_CMD_VARIABLE_EQ:
		{
			int x;
			int dx2,dy2;
			int dx3,dy3;

			x=stx+int(strlen("TEST ")*font->get_dx());

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,sty+2);

			vwnd->script_size(script->vpar2,&dx3,&dy3);
			vwnd->draw_script(sfc,script->vpar2,x+dx2+6+3*font->get_dx(),sty+2);

			font->print(stx+2,sty+4,"TEST ",sfc);
			font->print(x+dx2+6,sty+4," = ",sfc);
		}
		break;
	case CONDITION_CMD_VARIABLE_GR:
		{
			int x;
			int dx2,dy2;
			int dx3,dy3;

			x=stx+int(strlen("TEST ")*font->get_dx());

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,sty+2);

			vwnd->script_size(script->vpar2,&dx3,&dy3);
			vwnd->draw_script(sfc,script->vpar2,x+dx2+6+3*font->get_dx(),sty+2);

			font->print(stx+2,sty+4,"TEST ",sfc);
			font->print(x+dx2+6,sty+4," > ",sfc);
		}
		break;
	case CONDITION_CMD_VARIABLE_GREQ:
		{
			int x;
			int dx2,dy2;
			int dx3,dy3;

			x=stx+int(strlen("TEST ")*font->get_dx());

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,sty+2);

			vwnd->script_size(script->vpar2,&dx3,&dy3);
			vwnd->draw_script(sfc,script->vpar2,x+dx2+6+4*font->get_dx(),sty+2);

			font->print(stx+2,sty+4,"TEST ",sfc);
			font->print(x+dx2+6,sty+4," >= ",sfc);
		}
		break;
	case CONDITION_CMD_VARIABLE_LW:
		{
			int x;
			int dx2,dy2;
			int dx3,dy3;

			x=stx+int(strlen("TEST ")*font->get_dx());

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,sty+2);

			vwnd->script_size(script->vpar2,&dx3,&dy3);
			vwnd->draw_script(sfc,script->vpar2,x+dx2+6+3*font->get_dx(),sty+2);

			font->print(stx+2,sty+4,"TEST ",sfc);
			font->print(x+dx2+6,sty+4," < ",sfc);
		}
		break;
	case CONDITION_CMD_VARIABLE_LWEQ:
		{
			int x;
			int dx2,dy2;
			int dx3,dy3;

			x=stx+int(strlen("TEST ")*font->get_dx());

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->draw_script(sfc,script->vpar,x+2,sty+2);

			vwnd->script_size(script->vpar2,&dx3,&dy3);
			vwnd->draw_script(sfc,script->vpar2,x+dx2+6+4*font->get_dx(),sty+2);

			font->print(stx+2,sty+4,"TEST ",sfc);
			font->print(x+dx2+6,sty+4," <= ",sfc);
		}
		break;
	} /* switch */ 
} /* BViewConditionScriptWnd::draw_script */ 


bool BViewConditionScriptWnd::click_on_condition_script(ConditionSCRIPT *script,int stx,int sty)
{
	int dx,dy;
//	char tmp[256];

	condition_script_size(script,&dx,&dy);

	switch(script->command) {
	case CONDITION_CMD_TRUE:
		break;
	case CONDITION_CMD_FALSE:
		break;

	case CONDITION_CMD_NOT:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x,y;

			x=stx+int(strlen("NOT ( ")*font->get_dx());
			y=sty+2;

			if (click_on_condition_script(script->aparlist[0],x,y)) return true;
		} /* if */ 
		break;
	case CONDITION_CMD_AND:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {

			List<ConditionSCRIPT> l;
			ConditionSCRIPT *as;
			int x,y;

			x=stx+int(strlen("AND ( ")*font->get_dx());
			y=sty+2;
			l.Instance(script->aparlist);
			l.Rewind();
			while(l.Iterate(as)) {
				int dx2,dy2;

				condition_script_size(as,&dx2,&dy2);
				if (click_on_condition_script(as,x,y)) return true;
				y+=dy2+6;
			} /* while */ 

			/* END: */ 
			if (local_mouse_x>=x && local_mouse_y>=y &&
				local_mouse_x<x+3*font->get_dx()+4 && local_mouse_y<y+font->get_dy()+4) {
				script->aparlist.Add(new ConditionSCRIPT());
				return true;
			} /* if */ 

		} /* if */ 
		break;
	case CONDITION_CMD_OR:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {

			List<ConditionSCRIPT> l;
			ConditionSCRIPT *as;
			int x,y;

			x=stx+int(strlen("OR ( ")*font->get_dx());
			y=sty+2;
			l.Instance(script->aparlist);
			l.Rewind();
			while(l.Iterate(as)) {
				int dx2,dy2;

				condition_script_size(as,&dx2,&dy2);
				if (click_on_condition_script(as,x,y)) return true;
				y+=dy2+6;
			} /* while */ 

			/* END: */ 
			if (local_mouse_x>=x && local_mouse_y>=y &&
				local_mouse_x<x+3*font->get_dx()+4 && local_mouse_y<y+font->get_dy()+4) {
				script->aparlist.Add(new ConditionSCRIPT());
				return true;
			} /* if */ 

		} /* if */ 
		break;

	case CONDITION_CMD_TIMMER:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("TIMMER ( ")*font->get_dx());

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_COLLISION:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("COLLISION ( ")*font->get_dx());
			int dx2,dy2;

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			x=stx+int(strlen("COLLISION (  , ")*font->get_dx()+dx2+6);
			if (vwnd->click_on_script(script->vpar2,x,sty+2)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_INSIDE_ROOM:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("INSIDE_ROOM ( ")*font->get_dx());
			int dx2,dy2;

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			x=stx+int(strlen("INSIDE_ROOM (  , ")*font->get_dx()+dx2+6);
			if (vwnd->click_on_script(script->vpar2,x,sty+2)) return true;

		} /* if */ 
		break;

	case CONDITION_CMD_KEYPRESS:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("KEYPRESS ( ")*font->get_dx());

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_KEYPRESSED:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("KEYPRESSED ( ")*font->get_dx());

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

		} /* if */ 
		break;

	case CONDITION_CMD_VARIABLE_EQ:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("TEST ")*font->get_dx());
			int dx2,dy2;

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			x=stx+int(strlen("TEST  = ")*font->get_dx()+dx2+6);
			if (vwnd->click_on_script(script->vpar2,x,sty+2)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_VARIABLE_GR:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("TEST ")*font->get_dx());
			int dx2,dy2;

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			x=stx+int(strlen("TEST  > ")*font->get_dx()+dx2+6);
			if (vwnd->click_on_script(script->vpar2,x,sty+2)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_VARIABLE_GREQ:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("TEST ")*font->get_dx());
			int dx2,dy2;

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			x=stx+int(strlen("TEST  >= ")*font->get_dx()+dx2+6);
			if (vwnd->click_on_script(script->vpar2,x,sty+2)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_VARIABLE_LW:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("TEST ")*font->get_dx());
			int dx2,dy2;

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			x=stx+int(strlen("TEST  < ")*font->get_dx()+dx2+6);
			if (vwnd->click_on_script(script->vpar2,x,sty+2)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_VARIABLE_LWEQ:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x=stx+int(strlen("TEST ")*font->get_dx());
			int dx2,dy2;

			if (vwnd->click_on_script(script->vpar,x+2,sty+2)) return true;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			x=stx+int(strlen("TEST  <= ")*font->get_dx()+dx2+6);
			if (vwnd->click_on_script(script->vpar2,x,sty+2)) return true;

		} /* if */ 
		break;

	} /* switch */ 

	if (local_mouse_x>=stx && local_mouse_y>=sty &&
		local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
		int x,y;
		int res;
		BVChoiceDlg *dlg;

		x=mouse_x-100;
		y=mouse_y;
		if (x<0) x=0;
		if (y<0) y=0;
		if (x+160>SCREEN_X) x=SCREEN_X-160;
		if (y+280>SCREEN_Y) y=SCREEN_Y-280;
		dlg=new BVChoiceDlg(x,y,160,280,"Choose command:","true\nfalse\nnot\nand\nor\ntimmer\ncollision\ninside_room\nkeypress\nkeypressed\neq\ngr\ngreq\nlw\nlweq\n",&res,font);
		dlg->Execute();
		delete dlg;

		switch(res) {
		case 1:script->command=CONDITION_CMD_TRUE;
			break;
		case 2:script->command=CONDITION_CMD_FALSE;
			break;

		case 3:script->aparlist.Delete();
			   script->aparlist.Add(new ConditionSCRIPT());
			   script->command=CONDITION_CMD_NOT;
			break;
		case 4:if (script->command!=CONDITION_CMD_OR &&
				   script->command!=CONDITION_CMD_AND) {
				   script->aparlist.Delete();
				   script->aparlist.Add(new ConditionSCRIPT());
				   script->aparlist.Add(new ConditionSCRIPT());
			   } /* if */ 
			   script->command=CONDITION_CMD_AND;
			break;
		case 5:if (script->command!=CONDITION_CMD_OR &&
				   script->command!=CONDITION_CMD_AND) {
				   script->aparlist.Delete();
				   script->aparlist.Add(new ConditionSCRIPT());
				   script->aparlist.Add(new ConditionSCRIPT());
			   } /* if */ 
			   script->command=CONDITION_CMD_OR;
			break;

		case 6:script->command=CONDITION_CMD_TIMMER;
			   script->vpar=new ValueSCRIPT();
			break;
		case 7:script->command=CONDITION_CMD_COLLISION;
			   script->vpar=new ValueSCRIPT();
			   script->vpar2=new ValueSCRIPT();
			break;
		case 8:script->command=CONDITION_CMD_INSIDE_ROOM;
			   script->vpar=new ValueSCRIPT();
			   script->vpar2=new ValueSCRIPT();
			break;

		case 9:if (script->command!=CONDITION_CMD_KEYPRESS &&
				   script->command!=CONDITION_CMD_KEYPRESSED) {
				   delete script->vpar;
				   script->vpar=new ValueSCRIPT();
				   script->vpar->ipar=0;
			   } /* if */ 
			   script->command=CONDITION_CMD_KEYPRESS;			   
			break;
		case 10:if (script->command!=CONDITION_CMD_KEYPRESS &&
					script->command!=CONDITION_CMD_KEYPRESSED) {
				   delete script->vpar;
				   script->vpar=new ValueSCRIPT();
				   script->vpar->ipar=0;
				} /* if */ 
			    script->command=CONDITION_CMD_KEYPRESSED;
			break;

		case 11:if (script->command!=CONDITION_CMD_VARIABLE_EQ &&
					script->command!=CONDITION_CMD_VARIABLE_GR &&
					script->command!=CONDITION_CMD_VARIABLE_GREQ &&
					script->command!=CONDITION_CMD_VARIABLE_LW &&
					script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
					script->vpar=new ValueSCRIPT();
					script->vpar2=new ValueSCRIPT();
				} /* if */ 
				script->command=CONDITION_CMD_VARIABLE_EQ;
				
			break;
		case 12:if (script->command!=CONDITION_CMD_VARIABLE_EQ &&
					script->command!=CONDITION_CMD_VARIABLE_GR &&
					script->command!=CONDITION_CMD_VARIABLE_GREQ &&
					script->command!=CONDITION_CMD_VARIABLE_LW &&
					script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
					script->vpar=new ValueSCRIPT();
					script->vpar2=new ValueSCRIPT();
				} /* if */ 
				script->command=CONDITION_CMD_VARIABLE_GR;
			    
			break;
		case 13:if (script->command!=CONDITION_CMD_VARIABLE_EQ &&
					script->command!=CONDITION_CMD_VARIABLE_GR &&
					script->command!=CONDITION_CMD_VARIABLE_GREQ &&
					script->command!=CONDITION_CMD_VARIABLE_LW &&
					script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
					script->vpar=new ValueSCRIPT();
					script->vpar2=new ValueSCRIPT();
				} /* if */ 
				script->command=CONDITION_CMD_VARIABLE_GREQ;
			    
			break;
		case 14:if (script->command!=CONDITION_CMD_VARIABLE_EQ &&
					script->command!=CONDITION_CMD_VARIABLE_GR &&
					script->command!=CONDITION_CMD_VARIABLE_GREQ &&
					script->command!=CONDITION_CMD_VARIABLE_LW &&
					script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
					script->vpar=new ValueSCRIPT();
					script->vpar2=new ValueSCRIPT();
				} /* if */ 
				script->command=CONDITION_CMD_VARIABLE_LW;
			    
			break;
		case 15:if (script->command!=CONDITION_CMD_VARIABLE_EQ &&
					script->command!=CONDITION_CMD_VARIABLE_GR &&
					script->command!=CONDITION_CMD_VARIABLE_GREQ &&
					script->command!=CONDITION_CMD_VARIABLE_LW &&
					script->command!=CONDITION_CMD_VARIABLE_LWEQ) {
					script->vpar=new ValueSCRIPT();
					script->vpar2=new ValueSCRIPT();
				} /* if */ 
				script->command=CONDITION_CMD_VARIABLE_LWEQ;
			    
			break;

		} /* switch */ 
		return true;
	} /* if */ 

	return false;
} /* BViewConditionScriptWnd::click_on_condition_script */ 


bool BViewConditionScriptWnd::right_click_on_condition_script(ConditionSCRIPT *script,int stx,int sty)
{
	int dx,dy;

	condition_script_size(script,&dx,&dy);

	switch(script->command) {
	case CONDITION_CMD_TRUE:
		break;
	case CONDITION_CMD_FALSE:
		break;

	case CONDITION_CMD_NOT:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
			int x,y;
			int operation=0;

			x=stx+int(strlen("NOT ( ")*font->get_dx());
			y=sty+2;

			if (right_click_on_condition_script(script->aparlist[0],x,y)) return true;

		} /* if */ 
		break;
	case CONDITION_CMD_AND:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {

			List<ConditionSCRIPT> l,todelete;
			ConditionSCRIPT *as;
			int x,y;

			x=stx+int(strlen("AND ( ")*font->get_dx());
			y=sty+2;
			l.Instance(script->aparlist);
			l.Rewind();
			while(l.Iterate(as)) {
				int dx2,dy2;
				int operation=0;

				condition_script_size(as,&dx2,&dy2);
				if (right_click_on_condition_script(as,x,y)) return true;
				y+=dy2+6;
			} /* while */ 

			while(!todelete.EmptyP()) {
				as=todelete.ExtractIni();
				script->aparlist.DeleteElement(as);
				delete as;
			} /* while */ 

			/* END: */ 
			if (local_mouse_x>=x && local_mouse_y>=y &&
				local_mouse_x<x+3*font->get_dx()+4 && local_mouse_y<y+font->get_dy()+4) {
				return true;
			} /* if */ 

		} /* if */ 
		break;
	case CONDITION_CMD_OR:
		if (local_mouse_x>=stx && local_mouse_y>=sty &&
			local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {

			List<ConditionSCRIPT> l,todelete;
			ConditionSCRIPT *as;
			int x,y;

			x=stx+int(strlen("OR ( ")*font->get_dx());
			y=sty+2;
			l.Instance(script->aparlist);
			l.Rewind();
			while(l.Iterate(as)) {
				int dx2,dy2;
				int operation=0;

				condition_script_size(as,&dx2,&dy2);
				if (right_click_on_condition_script(as,x,y)) return true;
				y+=dy2+6;
			} /* while */ 

			while(!todelete.EmptyP()) {
				as=todelete.ExtractIni();
				script->aparlist.DeleteElement(as);
				delete as;
			} /* while */ 

			/* END: */ 
			if (local_mouse_x>=x && local_mouse_y>=y &&
				local_mouse_x<x+3*font->get_dx()+4 && local_mouse_y<y+font->get_dy()+4) {
				return true;
			} /* if */ 

		} /* if */ 
		break;

	case CONDITION_CMD_TIMMER:
		break;
	case CONDITION_CMD_COLLISION:
		break;
	case CONDITION_CMD_INSIDE_ROOM:
		break;

	case CONDITION_CMD_KEYPRESS:
		break;
	case CONDITION_CMD_KEYPRESSED:
		break;

	case CONDITION_CMD_VARIABLE_EQ:
		break;
	case CONDITION_CMD_VARIABLE_GR:
		break;
	case CONDITION_CMD_VARIABLE_GREQ:
		break;
	case CONDITION_CMD_VARIABLE_LW:
		break;
	case CONDITION_CMD_VARIABLE_LWEQ:
		break;
	} /* switch */ 

	if (local_mouse_x>=stx && local_mouse_y>=sty &&
		local_mouse_x<stx+dx+4 && local_mouse_y<sty+dy+4) {
		int x,y;
		int res;
		BVChoiceDlg *dlg;

		x=mouse_x-70;
		y=mouse_y-50;
		if (x<0) x=0;
		if (y<0) y=0;
		if (x+140>SCREEN_X) x=SCREEN_X-140;
		if (y+150>SCREEN_Y) y=SCREEN_Y-150;
		dlg=new BVChoiceDlg(x,y,140,150,"Operation:","Delete\nAnd after\nAnd before\nOr after\nOr before\nNegate\n",&res,font);
		dlg->Execute();
		delete dlg;

		if (res==1) {
			script->aparlist.Delete();
			script->command=CONDITION_CMD_DELETE;
		} /* if */ 

		if (res==2) {
			ConditionSCRIPT *tmp=new ConditionSCRIPT(*script);
			script->aparlist.Delete();
			script->aparlist.Add(tmp);
			script->aparlist.Add(new ConditionSCRIPT());
			script->command=CONDITION_CMD_AND;
		} /* uf */ 
		if (res==3) {
			ConditionSCRIPT *tmp=new ConditionSCRIPT(*script);
			script->aparlist.Delete();
			script->aparlist.Add(new ConditionSCRIPT());
			script->aparlist.Add(tmp);
			script->command=CONDITION_CMD_AND;
		} /* if */ 

		if (res==4) {
			ConditionSCRIPT *tmp=new ConditionSCRIPT(*script);
			script->aparlist.Delete();
			script->aparlist.Add(tmp);
			script->aparlist.Add(new ConditionSCRIPT());
			script->command=CONDITION_CMD_OR;
		} /* if */ 
		if (res==5) {
			ConditionSCRIPT *tmp=new ConditionSCRIPT(*script);
			script->aparlist.Delete();
			script->aparlist.Add(new ConditionSCRIPT());
			script->aparlist.Add(tmp);
			script->command=CONDITION_CMD_OR;
		} /* if */ 

		if (res==6) {
			ConditionSCRIPT *tmp;
			tmp=new ConditionSCRIPT(*script);

			script->aparlist.Delete();
			script->aparlist.Add(tmp);
			script->command=CONDITION_CMD_NOT;
		} /* if */ 

		return true;
	} /* if */ 

	return false;
} /* BViewConditionScriptWnd::right_click_on_condition_script */ 


void BViewConditionScriptWnd::condition_script_size(ConditionSCRIPT *script,int *dx,int *dy)
{
	switch(script->command) {
	case CONDITION_CMD_TRUE:
		*dx=int(strlen("TRUE"))*font->get_dx();
		*dy=font->get_dy();
		break;
	case CONDITION_CMD_FALSE:
		*dx=int(strlen("FALSE"))*font->get_dx();
		*dy=font->get_dy();
		break;

	case CONDITION_CMD_NOT:
		{
			int x,y;
			int dx2,dy2;

			x=int(strlen("NOT ( "))*font->get_dx();
			y=0;

			condition_script_size(script->aparlist[0],&dx2,&dy2);
			*dx=x+dx2+int(strlen(" )"))*font->get_dx();
			y+=dy2+6;

			*dy=y;
		}
		break;
	case CONDITION_CMD_AND:
		{
			List<ConditionSCRIPT> l;
			ConditionSCRIPT *as;
			int x,y;

			l.Instance(script->aparlist);
			l.Rewind();
			x=int(strlen("AND ( "))*font->get_dx();
			y=0;
			*dx=0;
			while(l.Iterate(as)) {
				int dx2,dy2;
				condition_script_size(as,&dx2,&dy2);
				if (*dx<x+dx2) *dx=x+dx2;
				y+=dy2+6;
			} /* while */ 
			y+=font->get_dy()+4;
			if (*dx<x+int(strlen("END )"))*font->get_dx()) *dx=x+int(strlen("END )"))*font->get_dx();
			*dy=y;
		}
		break;
	case CONDITION_CMD_OR:
		{
			List<ConditionSCRIPT> l;
			ConditionSCRIPT *as;
			int x,y;

			l.Instance(script->aparlist);
			l.Rewind();
			x=int(strlen("OR ( "))*font->get_dx();
			y=0;
			*dx=0;
			while(l.Iterate(as)) {
				int dx2,dy2;
				condition_script_size(as,&dx2,&dy2);
				if (*dx<x+dx2) *dx=x+dx2;
				y+=dy2+6;
			} /* while */ 
			y+=font->get_dy()+4;
			if (*dx<x+int(strlen("END )"))*font->get_dx()) *dx=x+int(strlen("END )"))*font->get_dx();
			*dy=y;
		}
		break;

	case CONDITION_CMD_TIMMER:
		{
			int dx2,dy2;

			vwnd->script_size(script->vpar,&dx2,&dy2);

			*dx=int(strlen("TIMMER (  )"))*font->get_dx()+dx2+4;
			*dy=dy2+4;
		}
		break;
	case CONDITION_CMD_COLLISION:
		{
			int dx2,dy2;
			int dx3,dy3;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->script_size(script->vpar2,&dx3,&dy3);

			*dx=int(strlen("COLLISION (  ,  )"))*font->get_dx()+dx2+4+dx3+4;
			if (dy2>dy3) *dy=dy2+4;
					else *dy=dy3+4;
		}
		break;
	case CONDITION_CMD_INSIDE_ROOM:
		{
			int dx2,dy2;
			int dx3,dy3;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->script_size(script->vpar2,&dx3,&dy3);

			*dx=int(strlen("INSIDE_ROOM (  ,  )"))*font->get_dx()+dx2+4+dx3+4;
			if (dy2>dy3) *dy=dy2+4;
					else *dy=dy3+4;
		}
		break;

	case CONDITION_CMD_KEYPRESS:
		{
			int dx2,dy2;

			vwnd->script_size(script->vpar,&dx2,&dy2);

			*dx=int(strlen("KEYPRESS (  )"))*font->get_dx()+dx2+4;
			*dy=dy2+4;
		}
		break;
	case CONDITION_CMD_KEYPRESSED:
		{
			int dx2,dy2;

			vwnd->script_size(script->vpar,&dx2,&dy2);

			*dx=int(strlen("KEYPRESSED (  )"))*font->get_dx()+dx2+4;
			*dy=dy2+4;
		}
		break;

	case CONDITION_CMD_VARIABLE_EQ:
		{
			int dx2,dy2;
			int dx3,dy3;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->script_size(script->vpar2,&dx3,&dy3);

			*dx=int(strlen("TEST  = "))*font->get_dx()+dx2+4+dx3+4;
			if (dy2>dy3) *dy=dy2+4;
					else *dy=dy3+4;
		}
		break;
	case CONDITION_CMD_VARIABLE_GR:
		{
			int dx2,dy2;
			int dx3,dy3;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->script_size(script->vpar2,&dx3,&dy3);

			*dx=int(strlen("TEST  > "))*font->get_dx()+dx2+4+dx3+4;
			if (dy2>dy3) *dy=dy2+4;
					else *dy=dy3+4;
		}
		break;
	case CONDITION_CMD_VARIABLE_GREQ:
		{
			int dx2,dy2;
			int dx3,dy3;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->script_size(script->vpar2,&dx3,&dy3);

			*dx=int(strlen("TEST  >= "))*font->get_dx()+dx2+4+dx3+4;
			if (dy2>dy3) *dy=dy2+4;
					else *dy=dy3+4;
		}
		break;
	case CONDITION_CMD_VARIABLE_LW:
		{
			int dx2,dy2;
			int dx3,dy3;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->script_size(script->vpar2,&dx3,&dy3);

			*dx=int(strlen("TEST  < "))*font->get_dx()+dx2+4+dx3+4;
			if (dy2>dy3) *dy=dy2+4;
					else *dy=dy3+4;
		}
		break;
	case CONDITION_CMD_VARIABLE_LWEQ:
		{
			int dx2,dy2;
			int dx3,dy3;

			vwnd->script_size(script->vpar,&dx2,&dy2);
			vwnd->script_size(script->vpar2,&dx3,&dy3);

			*dx=int(strlen("TEST  <= "))*font->get_dx()+dx2+4+dx3+4;
			if (dy2>dy3) *dy=dy2+4;
					else *dy=dy3+4;
		}
		break;

	default:
		*dx=0;
		*dy=0;
	} /* switch */ 

} /* BViewConditionScriptWnd::condition_script_size */ 
