#ifndef __BRAIN_GAME_DEBUG_WINDOW
#define __BRAIN_GAME_DEBUG_WINDOW


class GameDebugWindow : public BActiveWindow {
public:
	GameDebugWindow(int dx,int dy,TTF_Font *font,MOG2 *game,int game_mode,bool show_fps,char *file,List<NWMOG2PlayerInfo> *players);
	~GameDebugWindow();

	virtual void Execute(void);
	virtual bool cycle(int stx,int sty);

protected:
	virtual void contens_size(int *dx,int *dy);
	virtual void draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy);
	virtual bool event(SDL_Event *event);

	char *action_script_state(ActionSCRIPT *script);
	char *condition_script_state(ConditionSCRIPT *script);
	char *value_script_state(ValueSCRIPT *script);

	ActiveMOG2Application *app;
	ActiveMOG2 *game;

	bool show_fps;
	int game_mode;
	FILE *replay_fp;
	KEYBOARDSTATE **keyboardstate;
	int n_LVKs;
	int event_time,event_key,event_val;

	/* Debug Controls: */ 
	int running_mode;	/* 0 = stopped	*/ 
						/* 1 = step		*/ 
						/* 2 = run		*/ 
	BButton *bstop,*bstep,*brun;
	ActiveOBJECT *selected_object;
	ActionSCRIPT *selected_script;
	List<ActionSCRIPT> available_scripts;
	List<char> available_scripts_label;
	class BScriptDebugWnd *sdw;

	List<class INTERFACE> interfaces; /* Here's where the automatically generated interfaces are stored */ 
	List<class OBJECT> objects;

};

#endif