#ifdef _WIN32
#include "windows.h"
#include "direct.h"
#endif
#include "string.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"
#include "auxiliar.h"

#include "conditionscript.h"
#include "actionscript.h"
#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "interfaces.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "OVariableWnd.h"
#include "OVariableEditorWnd.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BOVariableEditorWnd::BOVariableEditorWnd(int x,int y,int dx,int dy,EDITOR *e,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int bx=20;
	int but_dx;

	but_dx=get_text_width("ACCEPT",font)+10;
	b=new BButton(bx,dy-20,but_dx,12,"ACCEPT",1);
	buttons.Add(b);
	bx+=but_dx+20;

	but_dx=get_text_width("ADD",font)+10;
	b=new BButton(bx,dy-20,but_dx,12,"ADD",2);
	buttons.Add(b);
	bx+=but_dx+20;

	editor=e;

	ovw=new OVariableWnd(10,10,dx-160,dy-60,editor,font);

} /* BOVariableEditorWnd::BOVariableEditorWnd */ 


BOVariableEditorWnd::~BOVariableEditorWnd()
{
	delete ovw;

} /* BOVariableEditorWnd::BOVariableEditorWnd */ 


void BOVariableEditorWnd::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BOVariableEditorWnd::contens_size */ 



bool BOVariableEditorWnd::cycle(int stx,int sty)
{
	if (!BActiveWindow::cycle(stx,sty)) return false;

	ovw->cycle(stx+10,sty+10);
	if (ovw->is_dirty()) set_dirty();

	return true;
} /* BOVariableEditorWnd::cycle */ 



void BOVariableEditorWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	r.x=10-stx;
	r.y=10-sty;
	r.w=dx-20;
	r.h=dy-60;
	SDL_FillRect(sfc,&r,0x00000000);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	ovw->draw(sfc,10-stx,10-sty,dx-20,dy-60);

} /* BOVariableEditorWnd::draw_contens */ 


bool BOVariableEditorWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		return false;
		break;
	case 2:
		/* ADD OBJECT VARIABLE: */ 
		{
			VARIABLE *v;
			List<VARIABLE> l;
			int i=0;
			char tmp[80];
			bool added=false,found;

			do{
				if (i==0) {
					sprintf(tmp,"new_variable");
				} else {
					sprintf(tmp,"new_variable_%i",i);
				} /* if */ 

				l.Instance(editor->ov_selected->object_variables);
				l.Rewind();
				found=false;
				while(!found && l.Iterate(v)) {
					if (v->cmp(tmp)) found=true;
				} /* while */ 

				if (!found) {
					v=new VARIABLE(tmp,0);
					editor->ov_selected->object_variables.Add(v);
					added=true;
				} /* if */ 

				i++;
			}while(!added);
			ovw->refind_variables=true;
			ovw->set_dirty();
			set_dirty();
		}
		return true;
		break;

	} /* switch */ 

	return false;
} /* BOVariableEditorWnd::button_pressed */ 

