#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "interfaces.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BStringEdDlg.h"
#include "BIntegerEdDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"
#include "OVariableWnd.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

extern int SCREEN_X,SCREEN_Y;

OVariableWnd::OVariableWnd(int x,int y,int dx,int dy,EDITOR *e,TTF_Font *font) : BWindow(x,y,dx,dy,font) 
{
	refind_variables=true;
	editor=e;
} /* OVariableWnd::OVariableWnd */ 


OVariableWnd::~OVariableWnd()
{
} /* OVariableWnd::~OVariableWnd */ 


bool OVariableWnd::cycle(int stx,int sty)
{
	BWindow::cycle(stx,sty);

	if (refind_variables) {
		List<MAP> lm;
		MAP *m;
		List<ROOM> lr;
		ROOM *r;
		List<VARIABLE> lv;
		VARIABLE *v;
		char *tmp;
		
		variable_names[0].Delete();
		variable_names[1].Delete();
		variable_names[2].Delete();
		variable_names[3].Delete();

		tmp=new char[6];
		strcpy(tmp,"state");
		variable_names[0].Add(tmp);

		tmp=new char[7];
		strcpy(tmp,"energy");
		variable_names[0].Add(tmp);

		tmp=new char[11];
		strcpy(tmp,"experience");
		variable_names[0].Add(tmp);

		switch(editor->ov_selected->constitution) {
		case CONS_NONE: 
						break;
		case CONS_SOLID:
 						break;
		case CONS_SOLID_SURFACE:
 						break;
		case CONS_WEAPON:
					tmp=new char[7];
					strcpy(tmp,"damage");
					variable_names[0].Add(tmp);

					tmp=new char[12];
					strcpy(tmp,"damage_type");
					variable_names[0].Add(tmp);
				 
					break;
		case CONS_LADDER:
					 							
						break;
		case CONS_CHARACTER: 

						break;
		} /* switch */ 
		switch(editor->ov_selected->control) {
		case CTRL_STANDARD:
			break;
		case CTRL_CHARACTER:
					tmp=new char[13];
					strcpy(tmp,"jumping_ctnt");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"gravity_ctnt");
					variable_names[0].Add(tmp);

					tmp=new char[14];
					strcpy(tmp,"walking_speed");
					variable_names[0].Add(tmp);

					tmp=new char[16];
					strcpy(tmp,"ladder_up_speed");
					variable_names[0].Add(tmp);

					tmp=new char[18];
					strcpy(tmp,"ladder_down_speed");
					variable_names[0].Add(tmp);
			break;
		case CTRL_TEXT:
					tmp=new char[10];
					strcpy(tmp,"text_text");
					variable_names[0].Add(tmp);

					tmp=new char[10];
					strcpy(tmp,"text_font");
					variable_names[0].Add(tmp);

					tmp=new char[10];
					strcpy(tmp,"text_size");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"text_spacing");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_r");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_g");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_b");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_a");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"text_h_align");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"text_v_align");
					variable_names[0].Add(tmp);

					tmp=new char[11];
					strcpy(tmp,"text_frame");
					variable_names[0].Add(tmp);

					tmp=new char[19];
					strcpy(tmp,"text_frame_point_x");
					variable_names[0].Add(tmp);
					
					tmp=new char[19];
					strcpy(tmp,"text_frame_point_y");
					variable_names[0].Add(tmp);

					tmp=new char[14];
					strcpy(tmp,"text_frame_r1");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_g1");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_b1");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_a1");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_r2");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_g2");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_b2");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_a2");
					variable_names[0].Add(tmp);
					
					tmp=new char[17];
					strcpy(tmp,"text_frame_width");
					variable_names[0].Add(tmp);

					tmp=new char[18];
					strcpy(tmp,"text_frame_radius");
					variable_names[0].Add(tmp);

					tmp=new char[11];
					strcpy(tmp,"text_max_w");
					variable_names[0].Add(tmp);
			break;
		case CTRL_GAMEWINDOW:
					tmp=new char[6];
					strcpy(tmp,"gw_dx");
					variable_names[0].Add(tmp);

					tmp=new char[6];
					strcpy(tmp,"gw_dy");
					variable_names[0].Add(tmp);
					
					tmp=new char[9];
					strcpy(tmp,"gw_scale");
					variable_names[0].Add(tmp);

					tmp=new char[12];
					strcpy(tmp,"gw_min_hs_x");
					variable_names[0].Add(tmp);

					tmp=new char[12];
					strcpy(tmp,"gw_min_hs_y");
					variable_names[0].Add(tmp);

					tmp=new char[12];
					strcpy(tmp,"gw_max_hs_x");
					variable_names[0].Add(tmp);

					tmp=new char[12];
					strcpy(tmp,"gw_max_hs_y");
					variable_names[0].Add(tmp);
			break;
		case CTRL_MENU:
					tmp=new char[8];
					strcpy(tmp,"menu_dx");
					variable_names[0].Add(tmp);

					tmp=new char[8];
					strcpy(tmp,"menu_dy");
					variable_names[0].Add(tmp);

					tmp=new char[11];
					strcpy(tmp,"menu_title");
					variable_names[0].Add(tmp);

					tmp=new char[22];
					strcpy(tmp,"menu_appearance_flags");
					variable_names[0].Add(tmp);

					tmp=new char[24];
					strcpy(tmp,"menu_entry_effect_flags");
					variable_names[0].Add(tmp);

					tmp=new char[18];
					strcpy(tmp,"menu_blink_timmer");
					variable_names[0].Add(tmp);

					tmp=new char[17];
					strcpy(tmp,"menu_zoom_factor");
					variable_names[0].Add(tmp);

					tmp=new char[19];
					strcpy(tmp,"menu_appear_factor");
					variable_names[0].Add(tmp);

					tmp=new char[10];
					strcpy(tmp,"text_font");
					variable_names[0].Add(tmp);

					tmp=new char[10];
					strcpy(tmp,"text_size");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"text_spacing");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_r");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_g");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_b");
					variable_names[0].Add(tmp);

					tmp=new char[7];
					strcpy(tmp,"text_a");
					variable_names[0].Add(tmp);

					tmp=new char[14];
					strcpy(tmp,"text_frame_r1");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_g1");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_b1");
					variable_names[0].Add(tmp);
					
					tmp=new char[14];
					strcpy(tmp,"text_frame_a1");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"menu_text_r2");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"menu_text_g2");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"menu_text_b2");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"menu_text_a2");
					variable_names[0].Add(tmp);

					tmp=new char[13];
					strcpy(tmp,"text_h_align");
					variable_names[0].Add(tmp);
			break;
		} /* switch */ 
		/* Temporal variables: */ 
		lv.Instance(editor->ov_selected->object_variables);
		lv.Rewind();
		while(lv.Iterate(v)) {
			tmp=new char[strlen(v->name)+1];
			strcpy(tmp,v->name);
			variable_names[0].Add(tmp);
		} /* while */ 


		/* Room variables: */ 
		lm.Instance(editor->game->maps);
		lm.Rewind();
		while(lm.Iterate(m)) {
			lr.Instance(m->rooms);
			lr.Rewind();
			while(lr.Iterate(r)) {
				lv.Instance(r->room_variables);
				lv.Rewind();
				while(lv.Iterate(v)) {
					tmp=new char[strlen(v->name)+1];
					strcpy(tmp,v->name);
					variable_names[1].Add(tmp);
				} /* while */ 
			} /* while */ 
		} /* while */ 

		/* Map variables: */ 
		lm.Instance(editor->game->maps);
		lm.Rewind();
		while(lm.Iterate(m)) {
			lv.Instance(m->map_variables);
			lv.Rewind();
			while(lv.Iterate(v)) {
				tmp=new char[strlen(v->name)+1];
				strcpy(tmp,v->name);
				variable_names[2].Add(tmp);
			} /* while */ 
		} /* while */ 

		lv.Instance(editor->game->game_variables);
		lv.Rewind();
		while(lv.Iterate(v)) {
			tmp=new char[strlen(v->name)+1];
			strcpy(tmp,v->name);
			variable_names[3].Add(tmp);
		} /* while */ 

		refind_variables=false;
		set_dirty();
	} /* if */ 


	/* Object variables: */ 
	if (( (mouse_button&SDL_BUTTON(1) &&
		  !(old_mouse_button&SDL_BUTTON(1)) ) ||
		  (mouse_button&SDL_BUTTON(3) &&
		  !(old_mouse_button&SDL_BUTTON(3)) ) )) {

		int i,y;
		char *tmp;
		char tmp2[256];

		y=3;
		for(i=0;i<4;i++) {
			y+=10;
			variable_names[i].Rewind();
			while(variable_names[i].Iterate(tmp)) {
				if (i==0) {
					if (strcmp(tmp,"state")==0) {
						sprintf(tmp2,"STATE: %i",editor->ov_selected->init_state);
					} else if (strcmp(tmp,"energy")==0) {
						sprintf(tmp2,"ENERGY: %i",editor->ov_selected->init_energy);
					} else if (strcmp(tmp,"experience")==0) {
						sprintf(tmp2,"EXPERIENCE: %i",editor->ov_selected->experience);
					} else if (strcmp(tmp,"damage")==0) {
						sprintf(tmp2,"DAMAGE: %i",editor->ov_selected->damage);
					} else if (strcmp(tmp,"damage_type")==0) {
						if (editor->ov_selected->damage_type!=0) {
							sprintf(tmp2,"DAMAGE_TYPE: %s",editor->ov_selected->damage_type);
						} else {
							sprintf(tmp2,"DAMAGE_TYPE: -");
						} /* if */ 
					} else {
						int ival;
						char *sval=0;
						if (editor->ov_selected->get_variable_value(tmp,&ival,&sval)) {
							sprintf(tmp2,"%s: %i",tmp,ival);
						} else {
							if (sval!=0) sprintf(tmp2,"%s: %s",tmp,sval);
							        else sprintf(tmp2,"%s: -",tmp);
						} /* if */ 
					} /* if */ 
				} else {
					sprintf(tmp2,"%s",tmp);
				} /* if */ 

				if (local_mouse_x>=10 && local_mouse_x<10+get_text_width(tmp2,font) &&
					local_mouse_y>=y && local_mouse_y<y+TTF_FontHeight(font)) {
					int y,x;
					if (i==0) {
						BVChoiceDlg *dlg;
						int res=0;
						List<VARIABLE> l;
						VARIABLE *v;
						bool found;

						l.Instance(editor->ov_selected->object_variables);
						l.Rewind();
						found=false;
						while(!found && l.Iterate(v)) {
							if (v->cmp(tmp)) found=true;
						} /* while */ 

						if (found) {
							dlg=new BVChoiceDlg(-1,-1,0,0,"Choose action:","Delete\nRename\nInteger Value\nString Value\n",&res,font);
							dlg->Execute();
							delete dlg;
						} else {
							if (strcmp("damage_type",tmp)==0 ||
								strcmp("text_text",tmp)==0 ||
								strcmp("text_font",tmp)==0 ||
								strcmp("menu_title",tmp)==0) {
								res=4;
							} else {
								res=3;
							} /* if */ 
						} /* if */ 
							
							if (res==1) {
							/* Delete the variable: */ 
							List<VARIABLE> l;
							VARIABLE *v;
							bool found;

							l.Instance(editor->ov_selected->object_variables);
							l.Rewind();
							found=false;
							while(!found && l.Iterate(v)) {
								if (v->cmp(tmp)) {
									found=true;
									editor->ov_selected->object_variables.DeleteElement(v);
									delete v;
								} /* if */ 
							} /* while */ 
							refind_variables=true;
						} /* if */ 

						if (res==2) {
							/* Rename the variable: */ 
							List<VARIABLE> l;
							VARIABLE *v,*v2;
							bool found;
							BStringEdDlg *dlg;
							char tmp2[256];

							l.Instance(editor->ov_selected->object_variables);
							l.Rewind();
							found=false;
							while(!found && l.Iterate(v2)) {
								if (v2->cmp(tmp)) {
									v=v2;
									found=true;
								} /* if */ 
							} /* while */ 

							strcpy(tmp2,v->name);
							new_window_coordinates(320,60,&x,&y);
							dlg=new BStringEdDlg(x,y,320,60,"Enter variable name:",tmp2,40," ",font);
							dlg->Execute();
							delete dlg;

							delete []v->name;
							v->name=new char[strlen(tmp2)+1];
							strcpy(v->name,tmp2);

							refind_variables=true;
						} /* if */ 

						if (res==3) {
							BIntegerEdDlg *dlg;
							int i;
							char tmp2[256];

							if (editor->ov_selected->get_variable_value(tmp,&i,(char **)&tmp2)!=VALUE_INTEGER) i=0;

							new_window_coordinates(140,60,&x,&y);	
							dlg=new BIntegerEdDlg(x,y,140,60,"Enter initial value:",&i,8,font);
							dlg->Execute();
							delete dlg;

							editor->ov_selected->set_variable_value(tmp,i);
						} /* if */ 

						if (res==4) {
							BStringEdDlg *dlg;
							int i;
							char *tmp3,tmp2[256];

							if (editor->ov_selected->get_variable_value(tmp,&i,&tmp3)!=VALUE_STRING) {
								tmp2[0]=0;
							} else {
								if (tmp3!=0) {
									strcpy(tmp2,tmp3);
								} else {
									tmp2[0]=0;
								} /* if */ 
							} /* if */ 

							new_window_coordinates(int(SCREEN_X*0.8),60,&x,&y);	
							dlg=new BStringEdDlg(x,y,int(SCREEN_X*0.8),60,"Enter initial value:",tmp2,128,"",font);
							dlg->Execute();
							delete dlg;

							editor->ov_selected->set_variable_value(tmp,tmp2);
						} /* if */ 

						set_dirty();

					} /* if */ 
					set_dirty();
				} /* if */ 

				y+=10;
			} /* while */ 
			y+=10;
		} /* for */ 
	} /* if */ 

	return true;
} /* OVariableWnd::cycle */ 


void OVariableWnd::contens_size(int *dx,int *dy)
{
	int i,y;
	int max_x=0;
	int max_y=0;
	char *tmp;
	char tmp2[256];

	max_x=2+get_text_width("OBJECT VARIABLES:",font);

	y=3;
	for(i=0;i<4;i++) {
		y+=10;
		variable_names[i].Rewind();
		while(variable_names[i].Iterate(tmp)) {
			if (i==0) {
					int ival;
					char *sval;
					int type;
					type=editor->ov_selected->get_variable_value(tmp,&ival,&sval);
					if (type==VALUE_INTEGER) {
						sprintf(tmp2,"%s: %i",tmp,ival);
					} else if (type==VALUE_STRING && sval!=0) {
						sprintf(tmp2,"%s: %s",tmp,sval);
					} else {
						sprintf(tmp2,"%s: -",tmp);
					} /* if */ 
					if (10+get_text_width(tmp2,font)>max_x) max_x=10+get_text_width(tmp2,font);
			} else {
				if (10+get_text_width(tmp,font)>max_x) max_x=10+get_text_width(tmp,font);
			} /* if */ 
			y+=10;
		} /* while */ 
		y+=10;
	} /* for */ 

	max_y=y;

	if (max_x>*dx) *dx=max_x;
	if (max_y>*dy) *dy=max_y;
} /* OVariableWnd::contens_size */ 


void OVariableWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	int i,y;
	char *tmp;

	char tmp2[256];

	SDL_FillRect(sfc,0,0);

	BWindow::draw_contens(sfc,stx,sty,dx,dy);

	y=3;
	for(i=0;i<4;i++) {
		if (i==0) print_left("OBJECT VARIABLES:",font,255,255,255,sfc,2-stx,y-sty);
		if (i==1) print_left("ROOM VARIABLES:",font,255,255,255,sfc,2-stx,y-sty);
		if (i==2) print_left("MAP VARIABLES:",font,255,255,255,sfc,2-stx,y-sty);
		if (i==3) print_left("GAME VARIABLES:",font,255,255,255,sfc,2-stx,y-sty);
		y+=10;
		variable_names[i].Rewind();
		while(variable_names[i].Iterate(tmp)) {
			if (i==0) {
					int ival;
					char *sval;
					int type;
					type=editor->ov_selected->get_variable_value(tmp,&ival,&sval);
					if (type==VALUE_INTEGER) {
						sprintf(tmp2,"%s: %i",tmp,ival);
					} else if (type==VALUE_STRING && sval!=0) {
						sprintf(tmp2,"%s: %s",tmp,sval);
					} else {
						sprintf(tmp2,"%s: -",tmp);
					} /* if */ 
					print_left(tmp2,font,255,255,255,sfc,10-stx,y-sty);
			} else {
				print_left(tmp,font,255,255,255,sfc,10-stx,y-sty);
			} /* if */ 
			y+=10;
		} /* while */ 
		y+=10;
	} /* for */ 

} /* OVariableWnd::draw_contens */ 

