#ifdef _WIN32
#include "windows.h"
#include "direct.h"
#endif

#include "string.h"

#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_mixer.h"

#include "List.h"
#include "auxiliar.h"

#include "conditionscript.h"
#include "actionscript.h"
#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "samples.h"
#include "interfaces.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BListWnd.h"
#include "SampleSelectorDlg.h"

#include "valuescript.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

SampleSelectorDlg::SampleSelectorDlg(int x,int y,int dx,int dy,EDITOR *e,SAMPLE **sp,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int bx=20;
	int but_dx;

	but_dx=get_text_width("ACCEPT",font)+10;
	b=new BButton(bx,dy-20,but_dx,12,"ACCEPT",1);
	buttons.Add(b);
	bx+=but_dx+20;

	but_dx=get_text_width("CANCEL",font)+10;
	b=new BButton(bx,dy-20,but_dx,12,"CANCEL",2);
	buttons.Add(b);
	bx+=but_dx+20;

	editor=e;
	s=sp;

	{
		SAMPLE *s2;
		List<SAMPLE> l;
		char *n;

		l.Instance(editor->game->samples);
		l.Rewind();
		while(l.Iterate(s2)) {
			n=new char[strlen(s2->name)+1];
			strcpy(n,s2->name);
			sample_names.Add(n);
		} /* while */ 
	}

	slw=new BListWnd(10,10,dx-20,dy-40,&sample_names,font);

} /* SampleSelectorDlg::BVariableSelectorWnd */ 


SampleSelectorDlg::~SampleSelectorDlg()
{
	delete slw;

} /* BVariableSelectorWnd::BVariableSelectorWnd */ 


void SampleSelectorDlg::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* SampleSelectorDlg::contens_size */ 



bool SampleSelectorDlg::cycle(int stx,int sty)
{
	if (!BActiveWindow::cycle(stx,sty)) return false;

	slw->cycle(stx+10,sty+10);
	if (slw->is_dirty()) set_dirty();

	return true;
} /* SampleSelectorDlg::cycle */ 



void SampleSelectorDlg::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	r.x=85-stx;
	r.y=10-sty;
	r.w=dx-95;
	r.h=dy-60;
	SDL_FillRect(sfc,&r,0x00000000);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	slw->draw(sfc,10-stx,10-sty,dx-95,dy-60);

} /* SampleSelectorDlg::draw_contens */ 


bool SampleSelectorDlg::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		{
			SAMPLE *s2;
			List<SAMPLE> l;

			l.Instance(editor->game->samples);
			l.Rewind();
			while(l.Iterate(s2)) {
				if (s2->cmp(slw->get_selected_name())) *s=s2;
			} /* while */ 
		}

		return false;
		break;

	case 2:
		*s=0;
		return false;
		break;

	} /* switch */ 

	return false;
} /* SampleSelectorDlg::button_pressed */ 

