#ifdef _WIN32
#include "windows.h"
#include "direct.h"
#endif

#include "string.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "List.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "tiles.h"

#include "BWindow.h"
#include "BFileListWnd.h"
#include "BActiveWindow.h"
#include "AnimScriptWnd.h"
#include "TileViewWnd.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BTileViewWnd::BTileViewWnd(int x,int y,int dx,int dy,OBJECT *o,int *r,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	object=o;
	res=r;
} /* BTileViewWnd::BTileSelectionWnd */ 


BTileViewWnd::~BTileViewWnd()
{
} /* BTileViewWnd::BTileViewWnd */ 


void BTileViewWnd::contens_size(int *dx,int *dy)
{
	int y,i;
	int max_x=0,max_y=0;
	int len=get_text_width("BITMAP 99",font);

	*dx=old_dx;
	*dy=old_dy;

	y=2;
	for(i=0;i<object->ntiles;i++) {
		if (max_x<object->tiles[i]->orig->w+len) max_x=object->tiles[i]->orig->w+len;
		y+=object->tiles[i]->orig->h+TTF_FontHeight(font)*2;
	} /* for */ 
	max_y=y;

	if (*dx<max_x) *dx=max_x;
	if (*dy<max_y) *dy=max_y;
} /* BTileViewWnd::contens_size */ 



bool BTileViewWnd::cycle(int stx,int sty)
{
	int y,i;

	if (!BActiveWindow::cycle(stx,sty)) return false;

	if (mouse_button&SDL_BUTTON(1) &&
		!(old_mouse_button&SDL_BUTTON(1)) &&
		local_mouse_x>=old_stx && 
		local_mouse_y>=old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy) {
		y=2;
		for(i=0;i<object->ntiles;i++) {
			if (local_mouse_x>=2 && local_mouse_x<2+object->tiles[i]->orig->w+get_text_width("BITMAP 99",font) &&
				local_mouse_y>=y && local_mouse_y<y+object->tiles[i]->orig->h) {
				*res=i;
				return false;
			} /* if */ 
			y+=object->tiles[i]->orig->h+TTF_FontHeight(font)*2;
		} /* for */ 
	} /* if */ 

	return true;
} /* BTileViewWnd::cycle */ 



void BTileViewWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	int i,y;
	SDL_Rect r;
	char tmp[80];

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x00000000);

	y=2;
	for(i=0;i<object->ntiles;i++) {
		sprintf(tmp,"BITMAP %.3i",i);
		print_left(tmp,font,255,255,255,sfc,2-stx,y-sty);
		object->tiles[i]->draw(32-stx,y+TTF_FontHeight(font)-sty,sfc);
		y+=object->tiles[i]->orig->h+TTF_FontHeight(font)*2;
	} /* for */ 

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

} /* BTileViewWnd::draw_contens */ 
 